#include <qbytearray.h>
#include <qcoreevent.h>
#include <qevent.h>
#include <qfont.h>
#include <qnamespace.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qpalette.h>
#include <qpoint.h>
#include <qsignalspy.h>
#include <qsize.h>
#include <qstyle.h>
#include <qtest_global.h>
#include <qtestaccessible.h>
#include <qtestdata.h>
#include <qtestevent.h>
#include <qtesteventloop.h>
#include <qvariant.h>
#include <qwidget.h>

#include <smoke.h>

#include <qttest_smoke.h>

static void *qttest_cast(void *xptr, Smoke::Index from, Smoke::Index to) {
    switch(from) {
      case 1:	//QActionEvent
	switch(to) {
	    case 10: return (void*)(QEvent*)(QActionEvent*)xptr;
	    case 1: return (void*)(QActionEvent*)(QActionEvent*)xptr;
	  default: return xptr;
	}
      case 2:	//QByteArray
	switch(to) {
	    case 2: return (void*)(QByteArray*)(QByteArray*)xptr;
	  default: return xptr;
	}
      case 3:	//QChildEvent
	switch(to) {
	    case 10: return (void*)(QEvent*)(QChildEvent*)xptr;
	    case 3: return (void*)(QChildEvent*)(QChildEvent*)xptr;
	  default: return xptr;
	}
      case 4:	//QCloseEvent
	switch(to) {
	    case 10: return (void*)(QEvent*)(QCloseEvent*)xptr;
	    case 4: return (void*)(QCloseEvent*)(QCloseEvent*)xptr;
	  default: return xptr;
	}
      case 5:	//QContextMenuEvent
	switch(to) {
	    case 10: return (void*)(QEvent*)(QContextMenuEvent*)xptr;
	    case 5: return (void*)(QContextMenuEvent*)(QContextMenuEvent*)xptr;
	  default: return xptr;
	}
      case 6:	//QDragEnterEvent
	switch(to) {
	    case 8: return (void*)(QDragMoveEvent*)(QDragEnterEvent*)xptr;
	    case 9: return (void*)(QDropEvent*)(QDragEnterEvent*)xptr;
	    case 10: return (void*)(QEvent*)(QDragEnterEvent*)xptr;
	    case 6: return (void*)(QDragEnterEvent*)(QDragEnterEvent*)xptr;
	  default: return xptr;
	}
      case 7:	//QDragLeaveEvent
	switch(to) {
	    case 10: return (void*)(QEvent*)(QDragLeaveEvent*)xptr;
	    case 7: return (void*)(QDragLeaveEvent*)(QDragLeaveEvent*)xptr;
	  default: return xptr;
	}
      case 8:	//QDragMoveEvent
	switch(to) {
	    case 9: return (void*)(QDropEvent*)(QDragMoveEvent*)xptr;
	    case 10: return (void*)(QEvent*)(QDragMoveEvent*)xptr;
	    case 8: return (void*)(QDragMoveEvent*)(QDragMoveEvent*)xptr;
	    case 6: return (void*)(QDragEnterEvent*)(QDragMoveEvent*)xptr;
	  default: return xptr;
	}
      case 9:	//QDropEvent
	switch(to) {
	    case 10: return (void*)(QEvent*)(QDropEvent*)xptr;
	    case 9: return (void*)(QDropEvent*)(QDropEvent*)xptr;
	    case 6: return (void*)(QDragEnterEvent*)(QDropEvent*)xptr;
	    case 8: return (void*)(QDragMoveEvent*)(QDropEvent*)xptr;
	  default: return xptr;
	}
      case 10:	//QEvent
	switch(to) {
	    case 10: return (void*)(QEvent*)(QEvent*)xptr;
	    case 1: return (void*)(QActionEvent*)(QEvent*)xptr;
	    case 3: return (void*)(QChildEvent*)(QEvent*)xptr;
	    case 4: return (void*)(QCloseEvent*)(QEvent*)xptr;
	    case 5: return (void*)(QContextMenuEvent*)(QEvent*)xptr;
	    case 6: return (void*)(QDragEnterEvent*)(QEvent*)xptr;
	    case 7: return (void*)(QDragLeaveEvent*)(QEvent*)xptr;
	    case 8: return (void*)(QDragMoveEvent*)(QEvent*)xptr;
	    case 9: return (void*)(QDropEvent*)(QEvent*)xptr;
	    case 11: return (void*)(QFocusEvent*)(QEvent*)xptr;
	    case 13: return (void*)(QHideEvent*)(QEvent*)xptr;
	    case 14: return (void*)(QInputMethodEvent*)(QEvent*)xptr;
	    case 15: return (void*)(QKeyEvent*)(QEvent*)xptr;
	    case 17: return (void*)(QMouseEvent*)(QEvent*)xptr;
	    case 18: return (void*)(QMoveEvent*)(QEvent*)xptr;
	    case 20: return (void*)(QPaintEvent*)(QEvent*)xptr;
	    case 23: return (void*)(QResizeEvent*)(QEvent*)xptr;
	    case 24: return (void*)(QShowEvent*)(QEvent*)xptr;
	    case 28: return (void*)(QTabletEvent*)(QEvent*)xptr;
	    case 36: return (void*)(QTimerEvent*)(QEvent*)xptr;
	    case 38: return (void*)(QWheelEvent*)(QEvent*)xptr;
	  default: return xptr;
	}
      case 11:	//QFocusEvent
	switch(to) {
	    case 10: return (void*)(QEvent*)(QFocusEvent*)xptr;
	    case 11: return (void*)(QFocusEvent*)(QFocusEvent*)xptr;
	  default: return xptr;
	}
      case 12:	//QFont
	switch(to) {
	    case 12: return (void*)(QFont*)(QFont*)xptr;
	  default: return xptr;
	}
      case 13:	//QHideEvent
	switch(to) {
	    case 10: return (void*)(QEvent*)(QHideEvent*)xptr;
	    case 13: return (void*)(QHideEvent*)(QHideEvent*)xptr;
	  default: return xptr;
	}
      case 14:	//QInputMethodEvent
	switch(to) {
	    case 10: return (void*)(QEvent*)(QInputMethodEvent*)xptr;
	    case 14: return (void*)(QInputMethodEvent*)(QInputMethodEvent*)xptr;
	  default: return xptr;
	}
      case 15:	//QKeyEvent
	switch(to) {
	    case 10: return (void*)(QEvent*)(QKeyEvent*)xptr;
	    case 15: return (void*)(QKeyEvent*)(QKeyEvent*)xptr;
	  default: return xptr;
	}
      case 16:	//QMetaObject
	switch(to) {
	    case 16: return (void*)(QMetaObject*)(QMetaObject*)xptr;
	  default: return xptr;
	}
      case 17:	//QMouseEvent
	switch(to) {
	    case 10: return (void*)(QEvent*)(QMouseEvent*)xptr;
	    case 17: return (void*)(QMouseEvent*)(QMouseEvent*)xptr;
	  default: return xptr;
	}
      case 18:	//QMoveEvent
	switch(to) {
	    case 10: return (void*)(QEvent*)(QMoveEvent*)xptr;
	    case 18: return (void*)(QMoveEvent*)(QMoveEvent*)xptr;
	  default: return xptr;
	}
      case 19:	//QObject
	switch(to) {
	    case 19: return (void*)(QObject*)(QObject*)xptr;
	    case 25: return (void*)(QSignalSpy*)(QObject*)xptr;
	    case 27: return (void*)(QStyle*)(QObject*)xptr;
	    case 35: return (void*)(QTestEventLoop*)(QObject*)xptr;
	    case 39: return (void*)(QWidget*)(QObject*)xptr;
	  default: return xptr;
	}
      case 20:	//QPaintEvent
	switch(to) {
	    case 10: return (void*)(QEvent*)(QPaintEvent*)xptr;
	    case 20: return (void*)(QPaintEvent*)(QPaintEvent*)xptr;
	  default: return xptr;
	}
      case 21:	//QPalette
	switch(to) {
	    case 21: return (void*)(QPalette*)(QPalette*)xptr;
	  default: return xptr;
	}
      case 22:	//QPoint
	switch(to) {
	    case 22: return (void*)(QPoint*)(QPoint*)xptr;
	  default: return xptr;
	}
      case 23:	//QResizeEvent
	switch(to) {
	    case 10: return (void*)(QEvent*)(QResizeEvent*)xptr;
	    case 23: return (void*)(QResizeEvent*)(QResizeEvent*)xptr;
	  default: return xptr;
	}
      case 24:	//QShowEvent
	switch(to) {
	    case 10: return (void*)(QEvent*)(QShowEvent*)xptr;
	    case 24: return (void*)(QShowEvent*)(QShowEvent*)xptr;
	  default: return xptr;
	}
      case 25:	//QSignalSpy
	switch(to) {
	    case 19: return (void*)(QObject*)(QSignalSpy*)xptr;
	    case 25: return (void*)(QSignalSpy*)(QSignalSpy*)xptr;
	  default: return xptr;
	}
      case 26:	//QSize
	switch(to) {
	    case 26: return (void*)(QSize*)(QSize*)xptr;
	  default: return xptr;
	}
      case 27:	//QStyle
	switch(to) {
	    case 19: return (void*)(QObject*)(QStyle*)xptr;
	    case 27: return (void*)(QStyle*)(QStyle*)xptr;
	  default: return xptr;
	}
      case 28:	//QTabletEvent
	switch(to) {
	    case 10: return (void*)(QEvent*)(QTabletEvent*)xptr;
	    case 28: return (void*)(QTabletEvent*)(QTabletEvent*)xptr;
	  default: return xptr;
	}
      case 30:	//QTestAccessibility
	switch(to) {
	    case 30: return (void*)(QTestAccessibility*)(QTestAccessibility*)xptr;
	  default: return xptr;
	}
      case 31:	//QTestAccessibilityEvent
	switch(to) {
	    case 31: return (void*)(QTestAccessibilityEvent*)(QTestAccessibilityEvent*)xptr;
	  default: return xptr;
	}
      case 32:	//QTestData
	switch(to) {
	    case 32: return (void*)(QTestData*)(QTestData*)xptr;
	  default: return xptr;
	}
      case 33:	//QTestDelayEvent
	switch(to) {
	    case 34: return (void*)(QTestEvent*)(QTestDelayEvent*)xptr;
	    case 33: return (void*)(QTestDelayEvent*)(QTestDelayEvent*)xptr;
	  default: return xptr;
	}
      case 34:	//QTestEvent
	switch(to) {
	    case 34: return (void*)(QTestEvent*)(QTestEvent*)xptr;
	    case 33: return (void*)(QTestDelayEvent*)(QTestEvent*)xptr;
	  default: return xptr;
	}
      case 35:	//QTestEventLoop
	switch(to) {
	    case 19: return (void*)(QObject*)(QTestEventLoop*)xptr;
	    case 35: return (void*)(QTestEventLoop*)(QTestEventLoop*)xptr;
	  default: return xptr;
	}
      case 36:	//QTimerEvent
	switch(to) {
	    case 10: return (void*)(QEvent*)(QTimerEvent*)xptr;
	    case 36: return (void*)(QTimerEvent*)(QTimerEvent*)xptr;
	  default: return xptr;
	}
      case 37:	//QVariant
	switch(to) {
	    case 37: return (void*)(QVariant*)(QVariant*)xptr;
	  default: return xptr;
	}
      case 38:	//QWheelEvent
	switch(to) {
	    case 10: return (void*)(QEvent*)(QWheelEvent*)xptr;
	    case 38: return (void*)(QWheelEvent*)(QWheelEvent*)xptr;
	  default: return xptr;
	}
      case 39:	//QWidget
	switch(to) {
	    case 19: return (void*)(QObject*)(QWidget*)xptr;
	    case 39: return (void*)(QWidget*)(QWidget*)xptr;
	  default: return xptr;
	}
      default: return xptr;
    }
}

// Group of Indexes (0 separated) used as super class lists.
// Classes with super classes have an index into this array.
static Smoke::Index qttest_inheritanceList[] = {
	0,	// 0: (no super class)
	19, 0,	// 1: QList, QObject
	34, 0,	// 3: QTestEvent
};

// These are the xenum functions for manipulating enum pointers
void xenum_QTest(Smoke::EnumOperation, Smoke::Index, void*&, long&);

// Those are the xcall functions defined in each x_*.cpp file, for dispatching method calls
void xcall_QSignalSpy(Smoke::Index, void*, Smoke::Stack);
void xcall_QTest(Smoke::Index, void*, Smoke::Stack);
void xcall_QTestAccessibility(Smoke::Index, void*, Smoke::Stack);
void xcall_QTestAccessibilityEvent(Smoke::Index, void*, Smoke::Stack);
void xcall_QTestData(Smoke::Index, void*, Smoke::Stack);
void xcall_QTestDelayEvent(Smoke::Index, void*, Smoke::Stack);
void xcall_QTestEvent(Smoke::Index, void*, Smoke::Stack);
void xcall_QTestEventLoop(Smoke::Index, void*, Smoke::Stack);

// List of all classes
// Name, index into inheritanceList, method dispatcher, enum dispatcher, class flags
static Smoke::Class qttest_classes[] = {
	{ 0L, false, 0, 0, 0, 0 }, 	// 0 (no class)
	{ "QActionEvent", true, 0, 0, 0, 0 }, 	// 1
	{ "QByteArray", true, 0, 0, 0, 0 }, 	// 2
	{ "QChildEvent", true, 0, 0, 0, 0 }, 	// 3
	{ "QCloseEvent", true, 0, 0, 0, 0 }, 	// 4
	{ "QContextMenuEvent", true, 0, 0, 0, 0 }, 	// 5
	{ "QDragEnterEvent", true, 0, 0, 0, 0 }, 	// 6
	{ "QDragLeaveEvent", true, 0, 0, 0, 0 }, 	// 7
	{ "QDragMoveEvent", true, 0, 0, 0, 0 }, 	// 8
	{ "QDropEvent", true, 0, 0, 0, 0 }, 	// 9
	{ "QEvent", true, 0, 0, 0, 0 }, 	// 10
	{ "QFocusEvent", true, 0, 0, 0, 0 }, 	// 11
	{ "QFont", true, 0, 0, 0, 0 }, 	// 12
	{ "QHideEvent", true, 0, 0, 0, 0 }, 	// 13
	{ "QInputMethodEvent", true, 0, 0, 0, 0 }, 	// 14
	{ "QKeyEvent", true, 0, 0, 0, 0 }, 	// 15
	{ "QMetaObject", true, 0, 0, 0, 0 }, 	// 16
	{ "QMouseEvent", true, 0, 0, 0, 0 }, 	// 17
	{ "QMoveEvent", true, 0, 0, 0, 0 }, 	// 18
	{ "QObject", true, 0, 0, 0, 0 }, 	// 19
	{ "QPaintEvent", true, 0, 0, 0, 0 }, 	// 20
	{ "QPalette", true, 0, 0, 0, 0 }, 	// 21
	{ "QPoint", true, 0, 0, 0, 0 }, 	// 22
	{ "QResizeEvent", true, 0, 0, 0, 0 }, 	// 23
	{ "QShowEvent", true, 0, 0, 0, 0 }, 	// 24
	{ "QSignalSpy", false, 1, xcall_QSignalSpy, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//25
	{ "QSize", true, 0, 0, 0, 0 }, 	// 26
	{ "QStyle", true, 0, 0, 0, 0 }, 	// 27
	{ "QTabletEvent", true, 0, 0, 0, 0 }, 	// 28
	{ "QTest", false, 0, xcall_QTest, xenum_QTest, Smoke::cf_deepcopy }, 	//29
	{ "QTestAccessibility", false, 0, xcall_QTestAccessibility, 0, Smoke::cf_deepcopy }, 	//30
	{ "QTestAccessibilityEvent", false, 0, xcall_QTestAccessibilityEvent, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//31
	{ "QTestData", false, 0, xcall_QTestData, 0, 0 }, 	//32
	{ "QTestDelayEvent", false, 3, xcall_QTestDelayEvent, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//33
	{ "QTestEvent", false, 0, xcall_QTestEvent, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//34
	{ "QTestEventLoop", false, 1, xcall_QTestEventLoop, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//35
	{ "QTimerEvent", true, 0, 0, 0, 0 }, 	// 36
	{ "QVariant", true, 0, 0, 0, 0 }, 	// 37
	{ "QWheelEvent", true, 0, 0, 0, 0 }, 	// 38
	{ "QWidget", true, 0, 0, 0, 0 }, 	// 39
	{ "Qt", true, 0, 0, 0, 0 }, 	// 40
};

// List of all types needed by the methods (arguments and return values)
// Name, class ID if arg is a class, and TypeId
static Smoke::Type qttest_types[] = {
	{ 0, 0, 0 },	//0 (no type)
	{ "QAbstractFileEngine::FileFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//1
	{ "QAbstractFileEngine::FileFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//2
	{ "QAbstractItemView::EditTriggers", 0, Smoke::t_uint | Smoke::tf_stack },	//3
	{ "QAbstractItemView::EditTriggers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//4
	{ "QAbstractPrintDialog::PrintDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//5
	{ "QAbstractPrintDialog::PrintDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//6
	{ "QAbstractSpinBox::StepEnabled", 0, Smoke::t_uint | Smoke::tf_stack },	//7
	{ "QAbstractSpinBox::StepEnabled&", 0, Smoke::t_voidp | Smoke::tf_ref },	//8
	{ "QAccessible::Relation", 0, Smoke::t_uint | Smoke::tf_stack },	//9
	{ "QAccessible::Relation&", 0, Smoke::t_voidp | Smoke::tf_ref },	//10
	{ "QAccessible::State", 0, Smoke::t_uint | Smoke::tf_stack },	//11
	{ "QAccessible::State&", 0, Smoke::t_voidp | Smoke::tf_ref },	//12
	{ "QActionEvent*", 1, Smoke::t_class | Smoke::tf_ptr },	//13
	{ "QByteArray", 2, Smoke::t_class | Smoke::tf_stack },	//14
	{ "QChildEvent*", 3, Smoke::t_class | Smoke::tf_ptr },	//15
	{ "QCloseEvent*", 4, Smoke::t_class | Smoke::tf_ptr },	//16
	{ "QColorDialog::ColorDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//17
	{ "QColorDialog::ColorDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//18
	{ "QContextMenuEvent*", 5, Smoke::t_class | Smoke::tf_ptr },	//19
	{ "QDBusConnection::RegisterOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//20
	{ "QDBusConnection::RegisterOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//21
	{ "QDateTimeEdit::Sections", 0, Smoke::t_uint | Smoke::tf_stack },	//22
	{ "QDateTimeEdit::Sections&", 0, Smoke::t_voidp | Smoke::tf_ref },	//23
	{ "QDialogButtonBox::StandardButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//24
	{ "QDialogButtonBox::StandardButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//25
	{ "QDir::Filters", 0, Smoke::t_uint | Smoke::tf_stack },	//26
	{ "QDir::Filters&", 0, Smoke::t_voidp | Smoke::tf_ref },	//27
	{ "QDir::SortFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//28
	{ "QDir::SortFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//29
	{ "QDirIterator::IteratorFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//30
	{ "QDirIterator::IteratorFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//31
	{ "QDockWidget::DockWidgetFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//32
	{ "QDockWidget::DockWidgetFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//33
	{ "QDragEnterEvent*", 6, Smoke::t_class | Smoke::tf_ptr },	//34
	{ "QDragLeaveEvent*", 7, Smoke::t_class | Smoke::tf_ptr },	//35
	{ "QDragMoveEvent*", 8, Smoke::t_class | Smoke::tf_ptr },	//36
	{ "QDropEvent*", 9, Smoke::t_class | Smoke::tf_ptr },	//37
	{ "QEvent*", 10, Smoke::t_class | Smoke::tf_ptr },	//38
	{ "QEventLoop::ProcessEventsFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//39
	{ "QEventLoop::ProcessEventsFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//40
	{ "QFile::Permissions", 0, Smoke::t_uint | Smoke::tf_stack },	//41
	{ "QFile::Permissions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//42
	{ "QFileDialog::Options", 0, Smoke::t_uint | Smoke::tf_stack },	//43
	{ "QFileDialog::Options&", 0, Smoke::t_voidp | Smoke::tf_ref },	//44
	{ "QFocusEvent*", 11, Smoke::t_class | Smoke::tf_ptr },	//45
	{ "QFontComboBox::FontFilters", 0, Smoke::t_uint | Smoke::tf_stack },	//46
	{ "QFontComboBox::FontFilters&", 0, Smoke::t_voidp | Smoke::tf_ref },	//47
	{ "QFontDialog::FontDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//48
	{ "QFontDialog::FontDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//49
	{ "QGL::FormatOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//50
	{ "QGL::FormatOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//51
	{ "QGLFormat::OpenGLVersionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//52
	{ "QGLFormat::OpenGLVersionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//53
	{ "QGraphicsItem::GraphicsItemFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//54
	{ "QGraphicsItem::GraphicsItemFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//55
	{ "QGraphicsScene::SceneLayers", 0, Smoke::t_uint | Smoke::tf_stack },	//56
	{ "QGraphicsScene::SceneLayers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//57
	{ "QGraphicsView::CacheMode", 0, Smoke::t_uint | Smoke::tf_stack },	//58
	{ "QGraphicsView::CacheMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//59
	{ "QGraphicsView::OptimizationFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//60
	{ "QGraphicsView::OptimizationFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//61
	{ "QHideEvent*", 13, Smoke::t_class | Smoke::tf_ptr },	//62
	{ "QIODevice::OpenMode", 0, Smoke::t_uint | Smoke::tf_stack },	//63
	{ "QIODevice::OpenMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//64
	{ "QImageIOPlugin::Capabilities", 0, Smoke::t_uint | Smoke::tf_stack },	//65
	{ "QImageIOPlugin::Capabilities&", 0, Smoke::t_voidp | Smoke::tf_ref },	//66
	{ "QInputDialog::InputDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//67
	{ "QInputDialog::InputDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//68
	{ "QInputMethodEvent*", 14, Smoke::t_class | Smoke::tf_ptr },	//69
	{ "QItemSelectionModel::SelectionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//70
	{ "QItemSelectionModel::SelectionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//71
	{ "QKeyEvent*", 15, Smoke::t_class | Smoke::tf_ptr },	//72
	{ "QLibrary::LoadHints", 0, Smoke::t_uint | Smoke::tf_stack },	//73
	{ "QLibrary::LoadHints&", 0, Smoke::t_voidp | Smoke::tf_ref },	//74
	{ "QList<QTestAccessibilityEvent>", 0, Smoke::t_voidp | Smoke::tf_stack },	//75
	{ "QLocale::NumberOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//76
	{ "QLocale::NumberOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//77
	{ "QMainWindow::DockOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//78
	{ "QMainWindow::DockOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//79
	{ "QMdiArea::AreaOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//80
	{ "QMdiArea::AreaOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//81
	{ "QMdiSubWindow::SubWindowOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//82
	{ "QMdiSubWindow::SubWindowOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//83
	{ "QMessageBox::StandardButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//84
	{ "QMessageBox::StandardButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//85
	{ "QMetaObject::Call", 16, Smoke::t_enum | Smoke::tf_stack },	//86
	{ "QMouseEvent*", 17, Smoke::t_class | Smoke::tf_ptr },	//87
	{ "QMoveEvent*", 18, Smoke::t_class | Smoke::tf_ptr },	//88
	{ "QNetworkInterface::InterfaceFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//89
	{ "QNetworkInterface::InterfaceFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//90
	{ "QNetworkProxy::Capabilities", 0, Smoke::t_uint | Smoke::tf_stack },	//91
	{ "QNetworkProxy::Capabilities&", 0, Smoke::t_voidp | Smoke::tf_ref },	//92
	{ "QObject*", 19, Smoke::t_class | Smoke::tf_ptr },	//93
	{ "QPageSetupDialog::PageSetupDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//94
	{ "QPageSetupDialog::PageSetupDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//95
	{ "QPaintEngine::DirtyFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//96
	{ "QPaintEngine::DirtyFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//97
	{ "QPaintEngine::PaintEngineFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//98
	{ "QPaintEngine::PaintEngineFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//99
	{ "QPaintEvent*", 20, Smoke::t_class | Smoke::tf_ptr },	//100
	{ "QPainter::RenderHints", 0, Smoke::t_uint | Smoke::tf_stack },	//101
	{ "QPainter::RenderHints&", 0, Smoke::t_voidp | Smoke::tf_ref },	//102
	{ "QPoint", 22, Smoke::t_class | Smoke::tf_stack },	//103
	{ "QResizeEvent*", 23, Smoke::t_class | Smoke::tf_ptr },	//104
	{ "QShowEvent*", 24, Smoke::t_class | Smoke::tf_ptr },	//105
	{ "QSignalSpy*", 25, Smoke::t_class | Smoke::tf_ptr },	//106
	{ "QSize", 26, Smoke::t_class | Smoke::tf_stack },	//107
	{ "QSizePolicy::ControlTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//108
	{ "QSizePolicy::ControlTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//109
	{ "QSql::ParamType", 0, Smoke::t_uint | Smoke::tf_stack },	//110
	{ "QSql::ParamType&", 0, Smoke::t_voidp | Smoke::tf_ref },	//111
	{ "QString", 0, Smoke::t_voidp | Smoke::tf_stack },	//112
	{ "QString::SectionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//113
	{ "QString::SectionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//114
	{ "QStyle&", 27, Smoke::t_class | Smoke::tf_ref },	//115
	{ "QStyle::State", 0, Smoke::t_uint | Smoke::tf_stack },	//116
	{ "QStyle::State&", 0, Smoke::t_voidp | Smoke::tf_ref },	//117
	{ "QStyle::SubControls", 0, Smoke::t_uint | Smoke::tf_stack },	//118
	{ "QStyle::SubControls&", 0, Smoke::t_voidp | Smoke::tf_ref },	//119
	{ "QStyleOptionButton::ButtonFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//120
	{ "QStyleOptionButton::ButtonFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//121
	{ "QStyleOptionFrameV2::FrameFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//122
	{ "QStyleOptionFrameV2::FrameFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//123
	{ "QStyleOptionQ3ListViewItem::Q3ListViewItemFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//124
	{ "QStyleOptionQ3ListViewItem::Q3ListViewItemFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//125
	{ "QStyleOptionTab::CornerWidgets", 0, Smoke::t_uint | Smoke::tf_stack },	//126
	{ "QStyleOptionTab::CornerWidgets&", 0, Smoke::t_voidp | Smoke::tf_ref },	//127
	{ "QStyleOptionToolBar::ToolBarFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//128
	{ "QStyleOptionToolBar::ToolBarFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//129
	{ "QStyleOptionToolButton::ToolButtonFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//130
	{ "QStyleOptionToolButton::ToolButtonFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//131
	{ "QStyleOptionViewItemV2::ViewItemFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//132
	{ "QStyleOptionViewItemV2::ViewItemFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//133
	{ "QTabletEvent*", 28, Smoke::t_class | Smoke::tf_ptr },	//134
	{ "QTest::KeyAction", 29, Smoke::t_enum | Smoke::tf_stack },	//135
	{ "QTest::MouseAction", 29, Smoke::t_enum | Smoke::tf_stack },	//136
	{ "QTest::SkipMode", 29, Smoke::t_enum | Smoke::tf_stack },	//137
	{ "QTest::TestFailMode", 29, Smoke::t_enum | Smoke::tf_stack },	//138
	{ "QTestAccessibilityEvent*", 31, Smoke::t_class | Smoke::tf_ptr },	//139
	{ "QTestData&", 32, Smoke::t_class | Smoke::tf_ref },	//140
	{ "QTestDelayEvent*", 33, Smoke::t_class | Smoke::tf_ptr },	//141
	{ "QTestEvent*", 34, Smoke::t_class | Smoke::tf_ptr },	//142
	{ "QTestEventLoop&", 35, Smoke::t_class | Smoke::tf_ref },	//143
	{ "QTestEventLoop*", 35, Smoke::t_class | Smoke::tf_ptr },	//144
	{ "QTestTable*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//145
	{ "QTextBoundaryFinder::BoundaryReasons", 0, Smoke::t_uint | Smoke::tf_stack },	//146
	{ "QTextBoundaryFinder::BoundaryReasons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//147
	{ "QTextCodec::ConversionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//148
	{ "QTextCodec::ConversionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//149
	{ "QTextDocument::FindFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//150
	{ "QTextDocument::FindFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//151
	{ "QTextEdit::AutoFormatting", 0, Smoke::t_uint | Smoke::tf_stack },	//152
	{ "QTextEdit::AutoFormatting&", 0, Smoke::t_voidp | Smoke::tf_ref },	//153
	{ "QTextFormat::PageBreakFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//154
	{ "QTextFormat::PageBreakFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//155
	{ "QTextItem::RenderFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//156
	{ "QTextItem::RenderFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//157
	{ "QTextOption::Flags", 0, Smoke::t_uint | Smoke::tf_stack },	//158
	{ "QTextOption::Flags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//159
	{ "QTextStream::NumberFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//160
	{ "QTextStream::NumberFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//161
	{ "QTimerEvent*", 36, Smoke::t_class | Smoke::tf_ptr },	//162
	{ "QTreeWidgetItemIterator::IteratorFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//163
	{ "QTreeWidgetItemIterator::IteratorFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//164
	{ "QUdpSocket::BindMode", 0, Smoke::t_uint | Smoke::tf_stack },	//165
	{ "QUdpSocket::BindMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//166
	{ "QUrl::FormattingOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//167
	{ "QUrl::FormattingOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//168
	{ "QVariant", 37, Smoke::t_class | Smoke::tf_stack },	//169
	{ "QWebPage::FindFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//170
	{ "QWebPage::FindFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//171
	{ "QWheelEvent*", 38, Smoke::t_class | Smoke::tf_ptr },	//172
	{ "QWidget*", 39, Smoke::t_class | Smoke::tf_ptr },	//173
	{ "QWidget::RenderFlag", 39, Smoke::t_enum | Smoke::tf_stack },	//174
	{ "QWidget::RenderFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//175
	{ "QWidget::RenderFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//176
	{ "QWizard::WizardOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//177
	{ "QWizard::WizardOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//178
	{ "Qt::Alignment", 0, Smoke::t_uint | Smoke::tf_stack },	//179
	{ "Qt::Alignment&", 0, Smoke::t_voidp | Smoke::tf_ref },	//180
	{ "Qt::AlignmentFlag", 40, Smoke::t_enum | Smoke::tf_stack },	//181
	{ "Qt::AnchorAttribute", 40, Smoke::t_enum | Smoke::tf_stack },	//182
	{ "Qt::ApplicationAttribute", 40, Smoke::t_enum | Smoke::tf_stack },	//183
	{ "Qt::ArrowType", 40, Smoke::t_enum | Smoke::tf_stack },	//184
	{ "Qt::AspectRatioMode", 40, Smoke::t_enum | Smoke::tf_stack },	//185
	{ "Qt::Axis", 40, Smoke::t_enum | Smoke::tf_stack },	//186
	{ "Qt::BGMode", 40, Smoke::t_enum | Smoke::tf_stack },	//187
	{ "Qt::BrushStyle", 40, Smoke::t_enum | Smoke::tf_stack },	//188
	{ "Qt::CaseSensitivity", 40, Smoke::t_enum | Smoke::tf_stack },	//189
	{ "Qt::CheckState", 40, Smoke::t_enum | Smoke::tf_stack },	//190
	{ "Qt::ClipOperation", 40, Smoke::t_enum | Smoke::tf_stack },	//191
	{ "Qt::ConnectionType", 40, Smoke::t_enum | Smoke::tf_stack },	//192
	{ "Qt::ContextMenuPolicy", 40, Smoke::t_enum | Smoke::tf_stack },	//193
	{ "Qt::Corner", 40, Smoke::t_enum | Smoke::tf_stack },	//194
	{ "Qt::CursorShape", 40, Smoke::t_enum | Smoke::tf_stack },	//195
	{ "Qt::DateFormat", 40, Smoke::t_enum | Smoke::tf_stack },	//196
	{ "Qt::DayOfWeek", 40, Smoke::t_enum | Smoke::tf_stack },	//197
	{ "Qt::DockWidgetArea", 40, Smoke::t_enum | Smoke::tf_stack },	//198
	{ "Qt::DockWidgetAreaSizes", 40, Smoke::t_enum | Smoke::tf_stack },	//199
	{ "Qt::DockWidgetAreas", 0, Smoke::t_uint | Smoke::tf_stack },	//200
	{ "Qt::DockWidgetAreas&", 0, Smoke::t_voidp | Smoke::tf_ref },	//201
	{ "Qt::DropAction", 40, Smoke::t_enum | Smoke::tf_stack },	//202
	{ "Qt::DropActions", 0, Smoke::t_uint | Smoke::tf_stack },	//203
	{ "Qt::DropActions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//204
	{ "Qt::EventPriority", 40, Smoke::t_enum | Smoke::tf_stack },	//205
	{ "Qt::FillRule", 40, Smoke::t_enum | Smoke::tf_stack },	//206
	{ "Qt::FocusPolicy", 40, Smoke::t_enum | Smoke::tf_stack },	//207
	{ "Qt::FocusReason", 40, Smoke::t_enum | Smoke::tf_stack },	//208
	{ "Qt::GlobalColor", 40, Smoke::t_enum | Smoke::tf_stack },	//209
	{ "Qt::HitTestAccuracy", 40, Smoke::t_enum | Smoke::tf_stack },	//210
	{ "Qt::ImageConversionFlag", 40, Smoke::t_enum | Smoke::tf_stack },	//211
	{ "Qt::ImageConversionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//212
	{ "Qt::ImageConversionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//213
	{ "Qt::InputMethodQuery", 40, Smoke::t_enum | Smoke::tf_stack },	//214
	{ "Qt::ItemDataRole", 40, Smoke::t_enum | Smoke::tf_stack },	//215
	{ "Qt::ItemFlag", 40, Smoke::t_enum | Smoke::tf_stack },	//216
	{ "Qt::ItemFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//217
	{ "Qt::ItemFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//218
	{ "Qt::ItemSelectionMode", 40, Smoke::t_enum | Smoke::tf_stack },	//219
	{ "Qt::Key", 40, Smoke::t_enum | Smoke::tf_stack },	//220
	{ "Qt::KeyboardModifier", 40, Smoke::t_enum | Smoke::tf_stack },	//221
	{ "Qt::KeyboardModifiers", 0, Smoke::t_uint | Smoke::tf_stack },	//222
	{ "Qt::KeyboardModifiers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//223
	{ "Qt::LayoutDirection", 40, Smoke::t_enum | Smoke::tf_stack },	//224
	{ "Qt::MaskMode", 40, Smoke::t_enum | Smoke::tf_stack },	//225
	{ "Qt::MatchFlag", 40, Smoke::t_enum | Smoke::tf_stack },	//226
	{ "Qt::MatchFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//227
	{ "Qt::MatchFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//228
	{ "Qt::Modifier", 40, Smoke::t_enum | Smoke::tf_stack },	//229
	{ "Qt::MouseButton", 40, Smoke::t_enum | Smoke::tf_stack },	//230
	{ "Qt::MouseButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//231
	{ "Qt::MouseButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//232
	{ "Qt::Orientation", 40, Smoke::t_enum | Smoke::tf_stack },	//233
	{ "Qt::Orientations", 0, Smoke::t_uint | Smoke::tf_stack },	//234
	{ "Qt::Orientations&", 0, Smoke::t_voidp | Smoke::tf_ref },	//235
	{ "Qt::PenCapStyle", 40, Smoke::t_enum | Smoke::tf_stack },	//236
	{ "Qt::PenJoinStyle", 40, Smoke::t_enum | Smoke::tf_stack },	//237
	{ "Qt::PenStyle", 40, Smoke::t_enum | Smoke::tf_stack },	//238
	{ "Qt::ScrollBarPolicy", 40, Smoke::t_enum | Smoke::tf_stack },	//239
	{ "Qt::ShortcutContext", 40, Smoke::t_enum | Smoke::tf_stack },	//240
	{ "Qt::SizeHint", 40, Smoke::t_enum | Smoke::tf_stack },	//241
	{ "Qt::SizeMode", 40, Smoke::t_enum | Smoke::tf_stack },	//242
	{ "Qt::SortOrder", 40, Smoke::t_enum | Smoke::tf_stack },	//243
	{ "Qt::TextElideMode", 40, Smoke::t_enum | Smoke::tf_stack },	//244
	{ "Qt::TextFlag", 40, Smoke::t_enum | Smoke::tf_stack },	//245
	{ "Qt::TextFormat", 40, Smoke::t_enum | Smoke::tf_stack },	//246
	{ "Qt::TextInteractionFlag", 40, Smoke::t_enum | Smoke::tf_stack },	//247
	{ "Qt::TextInteractionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//248
	{ "Qt::TextInteractionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//249
	{ "Qt::TimeSpec", 40, Smoke::t_enum | Smoke::tf_stack },	//250
	{ "Qt::ToolBarArea", 40, Smoke::t_enum | Smoke::tf_stack },	//251
	{ "Qt::ToolBarAreaSizes", 40, Smoke::t_enum | Smoke::tf_stack },	//252
	{ "Qt::ToolBarAreas", 0, Smoke::t_uint | Smoke::tf_stack },	//253
	{ "Qt::ToolBarAreas&", 0, Smoke::t_voidp | Smoke::tf_ref },	//254
	{ "Qt::ToolButtonStyle", 40, Smoke::t_enum | Smoke::tf_stack },	//255
	{ "Qt::TransformationMode", 40, Smoke::t_enum | Smoke::tf_stack },	//256
	{ "Qt::UIEffect", 40, Smoke::t_enum | Smoke::tf_stack },	//257
	{ "Qt::WhiteSpaceMode", 40, Smoke::t_enum | Smoke::tf_stack },	//258
	{ "Qt::WidgetAttribute", 40, Smoke::t_enum | Smoke::tf_stack },	//259
	{ "Qt::WindowFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//260
	{ "Qt::WindowFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//261
	{ "Qt::WindowFrameSection", 40, Smoke::t_enum | Smoke::tf_stack },	//262
	{ "Qt::WindowModality", 40, Smoke::t_enum | Smoke::tf_stack },	//263
	{ "Qt::WindowState", 40, Smoke::t_enum | Smoke::tf_stack },	//264
	{ "Qt::WindowStates", 0, Smoke::t_uint | Smoke::tf_stack },	//265
	{ "Qt::WindowStates&", 0, Smoke::t_voidp | Smoke::tf_ref },	//266
	{ "Qt::WindowType", 40, Smoke::t_enum | Smoke::tf_stack },	//267
	{ "QtMsgType", 0, Smoke::t_voidp | Smoke::tf_stack },	//268
	{ "bool", 0, Smoke::t_bool | Smoke::tf_stack },	//269
	{ "char", 0, Smoke::t_char | Smoke::tf_stack },	//270
	{ "char*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//271
	{ "char**", 0, Smoke::t_voidp | Smoke::tf_ptr },	//272
	{ "const QFont&", 12, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//273
	{ "const QMetaObject", 16, Smoke::t_class | Smoke::tf_stack | Smoke::tf_const },	//274
	{ "const QMetaObject*", 16, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//275
	{ "const QPalette&", 21, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//276
	{ "const QString&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//277
	{ "const QStringList&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//278
	{ "const QTestAccessibilityEvent&", 31, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//279
	{ "const QTestDelayEvent&", 33, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//280
	{ "const QTestEvent&", 34, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//281
	{ "const char*", 0, Smoke::t_voidp | Smoke::tf_ptr | Smoke::tf_const },	//282
	{ "const void*", 0, Smoke::t_voidp | Smoke::tf_ptr | Smoke::tf_const },	//283
	{ "int", 0, Smoke::t_int | Smoke::tf_stack },	//284
	{ "void*", 0, Smoke::t_voidp | Smoke::tf_stack },	//285
	{ "void**", 0, Smoke::t_voidp | Smoke::tf_ptr },	//286
};

static Smoke::Index qttest_argumentList[] = {
	0,	//0  (void)
	135, 173, 220, 0,	//1  QTest::KeyAction, QWidget*, Qt::Key  
	135, 173, 220, 112, 222, 0,	//5  QTest::KeyAction, QWidget*, Qt::Key, QString, Qt::KeyboardModifiers  
	135, 173, 220, 112, 222, 284, 0,	//11  QTest::KeyAction, QWidget*, Qt::Key, QString, Qt::KeyboardModifiers, int  
	135, 173, 220, 222, 0,	//18  QTest::KeyAction, QWidget*, Qt::Key, Qt::KeyboardModifiers  
	135, 173, 220, 222, 284, 0,	//23  QTest::KeyAction, QWidget*, Qt::Key, Qt::KeyboardModifiers, int  
	135, 173, 220, 270, 222, 0,	//29  QTest::KeyAction, QWidget*, Qt::Key, char, Qt::KeyboardModifiers  
	135, 173, 220, 270, 222, 284, 0,	//35  QTest::KeyAction, QWidget*, Qt::Key, char, Qt::KeyboardModifiers, int  
	135, 173, 270, 0,	//42  QTest::KeyAction, QWidget*, char  
	135, 173, 270, 222, 0,	//46  QTest::KeyAction, QWidget*, char, Qt::KeyboardModifiers  
	135, 173, 270, 222, 284, 0,	//51  QTest::KeyAction, QWidget*, char, Qt::KeyboardModifiers, int  
	136, 173, 230, 222, 103, 0,	//57  QTest::MouseAction, QWidget*, Qt::MouseButton, Qt::KeyboardModifiers, QPoint  
	136, 173, 230, 222, 103, 284, 0,	//63  QTest::MouseAction, QWidget*, Qt::MouseButton, Qt::KeyboardModifiers, QPoint, int  
	15, 0,	//70  QChildEvent*  
	162, 0,	//72  QTimerEvent*  
	173, 0,	//74  QWidget*  
	173, 103, 0,	//76  QWidget*, QPoint  
	173, 103, 284, 0,	//79  QWidget*, QPoint, int  
	173, 220, 0,	//83  QWidget*, Qt::Key  
	173, 220, 222, 0,	//86  QWidget*, Qt::Key, Qt::KeyboardModifiers  
	173, 220, 222, 284, 0,	//90  QWidget*, Qt::Key, Qt::KeyboardModifiers, int  
	173, 230, 0,	//95  QWidget*, Qt::MouseButton  
	173, 230, 222, 0,	//98  QWidget*, Qt::MouseButton, Qt::KeyboardModifiers  
	173, 230, 222, 103, 0,	//102  QWidget*, Qt::MouseButton, Qt::KeyboardModifiers, QPoint  
	173, 230, 222, 103, 284, 0,	//107  QWidget*, Qt::MouseButton, Qt::KeyboardModifiers, QPoint, int  
	173, 269, 284, 222, 112, 269, 0,	//113  QWidget*, bool, int, Qt::KeyboardModifiers, QString, bool  
	173, 269, 284, 222, 112, 269, 284, 0,	//120  QWidget*, bool, int, Qt::KeyboardModifiers, QString, bool, int  
	173, 270, 0,	//128  QWidget*, char  
	173, 270, 222, 0,	//131  QWidget*, char, Qt::KeyboardModifiers  
	173, 270, 222, 284, 0,	//135  QWidget*, char, Qt::KeyboardModifiers, int  
	173, 277, 0,	//140  QWidget*, const QString&  
	173, 277, 222, 0,	//143  QWidget*, const QString&, Qt::KeyboardModifiers  
	173, 277, 222, 284, 0,	//147  QWidget*, const QString&, Qt::KeyboardModifiers, int  
	220, 0,	//152  Qt::Key  
	268, 282, 0,	//154  QtMsgType, const char*  
	269, 282, 271, 271, 282, 282, 282, 284, 0,	//157  bool, const char*, char*, char*, const char*, const char*, const char*, int  
	269, 282, 282, 282, 284, 0,	//166  bool, const char*, const char*, const char*, int  
	269, 282, 282, 284, 0,	//172  bool, const char*, const char*, int  
	270, 0,	//177  char  
	279, 0,	//179  const QTestAccessibilityEvent&  
	280, 0,	//181  const QTestDelayEvent&  
	281, 0,	//183  const QTestEvent&  
	282, 0,	//185  const char*  
	282, 137, 282, 284, 0,	//187  const char*, QTest::SkipMode, const char*, int  
	282, 282, 0,	//192  const char*, const char*  
	282, 282, 138, 282, 284, 0,	//195  const char*, const char*, QTest::TestFailMode, const char*, int  
	282, 282, 282, 282, 282, 284, 0,	//201  const char*, const char*, const char*, const char*, const char*, int  
	282, 282, 284, 0,	//208  const char*, const char*, int  
	282, 284, 0,	//212  const char*, int  
	283, 0,	//215  const void*  
	283, 283, 282, 282, 282, 284, 0,	//217  const void*, const void*, const char*, const char*, const char*, int  
	284, 0,	//224  int  
	284, 282, 0,	//226  int, const char*  
	284, 283, 0,	//229  int, const void*  
	38, 0,	//232  QEvent*  
	86, 284, 286, 0,	//234  QMetaObject::Call, int, void**  
	93, 0,	//238  QObject*  
	93, 278, 0,	//240  QObject*, const QStringList&  
	93, 282, 0,	//243  QObject*, const char*  
	93, 284, 0,	//246  QObject*, int  
	93, 284, 272, 0,	//249  QObject*, int, char**  
	93, 284, 284, 0,	//253  QObject*, int, int  
	93, 38, 0,	//257  QObject*, QEvent*  
};

// Raw list of all methods, using munged names
static const char *qttest_methodNames[] = {
    "",	//0
    "Abort",	//1
    "Click",	//2
    "Continue",	//3
    "MouseClick",	//4
    "MouseDClick",	//5
    "MouseMove",	//6
    "MousePress",	//7
    "MouseRelease",	//8
    "Press",	//9
    "QSignalSpy",	//10
    "QSignalSpy#$",	//11
    "QTestAccessibilityEvent",	//12
    "QTestAccessibilityEvent#",	//13
    "QTestAccessibilityEvent#$",	//14
    "QTestAccessibilityEvent#$$",	//15
    "QTestDelayEvent",	//16
    "QTestDelayEvent#",	//17
    "QTestDelayEvent$",	//18
    "QTestEvent",	//19
    "QTestEvent#",	//20
    "QTestEventLoop",	//21
    "QTestEventLoop#",	//22
    "Release",	//23
    "SkipAll",	//24
    "SkipSingle",	//25
    "addColumnInternal",	//26
    "addColumnInternal$$",	//27
    "append",	//28
    "append$?",	//29
    "asciiToKey",	//30
    "asciiToKey$",	//31
    "changeInterval",	//32
    "changeInterval$",	//33
    "child",	//34
    "childEvent",	//35
    "childEvent#",	//36
    "cleanup",	//37
    "clearEvents",	//38
    "clone",	//39
    "compare_helper",	//40
    "compare_helper$$$$",	//41
    "compare_helper$$$$$$$$",	//42
    "compare_ptr_helper",	//43
    "compare_ptr_helper??$$$$",	//44
    "compare_string_helper",	//45
    "compare_string_helper$$$$$$",	//46
    "connectNotify",	//47
    "connectNotify$",	//48
    "currentDataTag",	//49
    "currentTestFailed",	//50
    "currentTestFunction",	//51
    "customEvent",	//52
    "customEvent#",	//53
    "data",	//54
    "data$",	//55
    "dataCount",	//56
    "dataTag",	//57
    "disconnectNotify",	//58
    "disconnectNotify$",	//59
    "enterLoop",	//60
    "enterLoop$",	//61
    "event",	//62
    "event#",	//63
    "eventFilter",	//64
    "eventFilter##",	//65
    "events",	//66
    "exitLoop",	//67
    "ignoreMessage",	//68
    "ignoreMessage?$",	//69
    "initialize",	//70
    "instance",	//71
    "isValid",	//72
    "keyClick",	//73
    "keyClick#$",	//74
    "keyClick#$$",	//75
    "keyClick#$$$",	//76
    "keyClicks",	//77
    "keyClicks#$",	//78
    "keyClicks#$$",	//79
    "keyClicks#$$$",	//80
    "keyEvent",	//81
    "keyEvent$#$",	//82
    "keyEvent$#$$",	//83
    "keyEvent$#$$$",	//84
    "keyPress",	//85
    "keyPress#$",	//86
    "keyPress#$$",	//87
    "keyPress#$$$",	//88
    "keyRelease",	//89
    "keyRelease#$",	//90
    "keyRelease#$$",	//91
    "keyRelease#$$$",	//92
    "keyToAscii",	//93
    "keyToAscii$",	//94
    "metaObject",	//95
    "mouseClick",	//96
    "mouseClick#$",	//97
    "mouseClick#$$",	//98
    "mouseClick#$$#",	//99
    "mouseClick#$$#$",	//100
    "mouseDClick",	//101
    "mouseDClick#$",	//102
    "mouseDClick#$$",	//103
    "mouseDClick#$$#",	//104
    "mouseDClick#$$#$",	//105
    "mouseEvent",	//106
    "mouseEvent$#$$#",	//107
    "mouseEvent$#$$#$",	//108
    "mouseMove",	//109
    "mouseMove#",	//110
    "mouseMove##",	//111
    "mouseMove##$",	//112
    "mousePress",	//113
    "mousePress#$",	//114
    "mousePress#$$",	//115
    "mousePress#$$#",	//116
    "mousePress#$$#$",	//117
    "mouseRelease",	//118
    "mouseRelease#$",	//119
    "mouseRelease#$$",	//120
    "mouseRelease#$$#",	//121
    "mouseRelease#$$#$",	//122
    "newRow",	//123
    "newRow$",	//124
    "object",	//125
    "operator==",	//126
    "operator==#",	//127
    "parent",	//128
    "qData",	//129
    "qData$$",	//130
    "qElementData",	//131
    "qElementData$$",	//132
    "qExec",	//133
    "qExec#",	//134
    "qExec#$",	//135
    "qExec#$?",	//136
    "qExec#?",	//137
    "qExpectFail",	//138
    "qExpectFail$$$$$",	//139
    "qFail",	//140
    "qFail$$$",	//141
    "qGlobalData",	//142
    "qGlobalData$$",	//143
    "qSkip",	//144
    "qSkip$$$$",	//145
    "qSleep",	//146
    "qSleep$",	//147
    "qVerify",	//148
    "qVerify$$$$$",	//149
    "qWait",	//150
    "qWait$",	//151
    "qWarn",	//152
    "qWarn$",	//153
    "qt_metacall",	//154
    "qt_metacall$$?",	//155
    "sendKeyEvent",	//156
    "sendKeyEvent$#$$$",	//157
    "sendKeyEvent$#$$$$",	//158
    "setChild",	//159
    "setChild$",	//160
    "setEvent",	//161
    "setEvent$",	//162
    "setObject",	//163
    "setObject#",	//164
    "signal",	//165
    "simulate",	//166
    "simulate#",	//167
    "simulateEvent",	//168
    "simulateEvent#$$$$$",	//169
    "simulateEvent#$$$$$$",	//170
    "staticMetaObject",	//171
    "testObject",	//172
    "timeout",	//173
    "timerEvent",	//174
    "timerEvent#",	//175
    "toHexRepresentation",	//176
    "toHexRepresentation$$",	//177
    "toString",	//178
    "toString$",	//179
    "toString?",	//180
    "tr",	//181
    "tr$",	//182
    "tr$$",	//183
    "verifyEvent",	//184
    "verifyEvent#",	//185
    "verifyEvent#$$",	//186
    "~QSignalSpy",	//187
    "~QTestAccessibilityEvent",	//188
    "~QTestData",	//189
    "~QTestDelayEvent",	//190
    "~QTestEvent",	//191
    "~QTestEventLoop",	//192
};

// (classId, name (index in methodNames), argumentList index, number of args, method flags, return type (index in types), xcall() index)
static Smoke::Method qttest_methods[] = {
	{19, 95, 0, 0, Smoke::mf_const, 275, 2},	//0 QObject::metaObject() const
	{19, 154, 234, 3, 0, 284, 3},	//1 QObject::qt_metacall(QMetaObject::Call, int, void**)
	{19, 62, 232, 1, 0, 269, 6},	//2 QObject::event(QEvent*)
	{19, 64, 257, 2, 0, 269, 7},	//3 QObject::eventFilter(QObject*, QEvent*)
	{19, 174, 72, 1, Smoke::mf_protected, 0, 49},	//4 QObject::timerEvent(QTimerEvent*)
	{19, 35, 70, 1, Smoke::mf_protected, 0, 50},	//5 QObject::childEvent(QChildEvent*)
	{19, 52, 232, 1, Smoke::mf_protected, 0, 51},	//6 QObject::customEvent(QEvent*)
	{19, 47, 185, 1, Smoke::mf_protected, 0, 52},	//7 QObject::connectNotify(const char*)
	{19, 58, 185, 1, Smoke::mf_protected, 0, 53},	//8 QObject::disconnectNotify(const char*)
	{25, 10, 243, 2, Smoke::mf_ctor, 106, 1},	//9 QSignalSpy::QSignalSpy(QObject*, const char*)
	{25, 72, 0, 0, Smoke::mf_const, 269, 2},	//10 QSignalSpy::isValid() const
	{25, 165, 0, 0, Smoke::mf_const, 14, 3},	//11 QSignalSpy::signal() const
	{25, 154, 234, 3, 0, 284, 4},	//12 QSignalSpy::qt_metacall(QMetaObject::Call, int, void**)
	{25, 187, 0, 0, Smoke::mf_dtor, 0, 5},	//13 QSignalSpy::~QSignalSpy()
	{29, 7, 0, 0, Smoke::mf_static|Smoke::mf_enum, 136, 1},	//14 QTest::MousePress (enum)
	{29, 8, 0, 0, Smoke::mf_static|Smoke::mf_enum, 136, 2},	//15 QTest::MouseRelease (enum)
	{29, 4, 0, 0, Smoke::mf_static|Smoke::mf_enum, 136, 3},	//16 QTest::MouseClick (enum)
	{29, 5, 0, 0, Smoke::mf_static|Smoke::mf_enum, 136, 4},	//17 QTest::MouseDClick (enum)
	{29, 6, 0, 0, Smoke::mf_static|Smoke::mf_enum, 136, 5},	//18 QTest::MouseMove (enum)
	{29, 9, 0, 0, Smoke::mf_static|Smoke::mf_enum, 135, 6},	//19 QTest::Press (enum)
	{29, 23, 0, 0, Smoke::mf_static|Smoke::mf_enum, 135, 7},	//20 QTest::Release (enum)
	{29, 2, 0, 0, Smoke::mf_static|Smoke::mf_enum, 135, 8},	//21 QTest::Click (enum)
	{29, 25, 0, 0, Smoke::mf_static|Smoke::mf_enum, 137, 9},	//22 QTest::SkipSingle (enum)
	{29, 24, 0, 0, Smoke::mf_static|Smoke::mf_enum, 137, 10},	//23 QTest::SkipAll (enum)
	{29, 1, 0, 0, Smoke::mf_static|Smoke::mf_enum, 138, 11},	//24 QTest::Abort (enum)
	{29, 3, 0, 0, Smoke::mf_static|Smoke::mf_enum, 138, 12},	//25 QTest::Continue (enum)
	{29, 113, 107, 5, Smoke::mf_static, 0, 13},	//26 QTest::mousePress(QWidget*, Qt::MouseButton, Qt::KeyboardModifiers, QPoint, int)
	{29, 113, 102, 4, Smoke::mf_static, 0, 14},	//27 QTest::mousePress(QWidget*, Qt::MouseButton, Qt::KeyboardModifiers, QPoint)
	{29, 113, 98, 3, Smoke::mf_static, 0, 15},	//28 QTest::mousePress(QWidget*, Qt::MouseButton, Qt::KeyboardModifiers)
	{29, 113, 95, 2, Smoke::mf_static, 0, 16},	//29 QTest::mousePress(QWidget*, Qt::MouseButton)
	{29, 118, 107, 5, Smoke::mf_static, 0, 17},	//30 QTest::mouseRelease(QWidget*, Qt::MouseButton, Qt::KeyboardModifiers, QPoint, int)
	{29, 118, 102, 4, Smoke::mf_static, 0, 18},	//31 QTest::mouseRelease(QWidget*, Qt::MouseButton, Qt::KeyboardModifiers, QPoint)
	{29, 118, 98, 3, Smoke::mf_static, 0, 19},	//32 QTest::mouseRelease(QWidget*, Qt::MouseButton, Qt::KeyboardModifiers)
	{29, 118, 95, 2, Smoke::mf_static, 0, 20},	//33 QTest::mouseRelease(QWidget*, Qt::MouseButton)
	{29, 96, 107, 5, Smoke::mf_static, 0, 21},	//34 QTest::mouseClick(QWidget*, Qt::MouseButton, Qt::KeyboardModifiers, QPoint, int)
	{29, 96, 102, 4, Smoke::mf_static, 0, 22},	//35 QTest::mouseClick(QWidget*, Qt::MouseButton, Qt::KeyboardModifiers, QPoint)
	{29, 96, 98, 3, Smoke::mf_static, 0, 23},	//36 QTest::mouseClick(QWidget*, Qt::MouseButton, Qt::KeyboardModifiers)
	{29, 96, 95, 2, Smoke::mf_static, 0, 24},	//37 QTest::mouseClick(QWidget*, Qt::MouseButton)
	{29, 101, 107, 5, Smoke::mf_static, 0, 25},	//38 QTest::mouseDClick(QWidget*, Qt::MouseButton, Qt::KeyboardModifiers, QPoint, int)
	{29, 101, 102, 4, Smoke::mf_static, 0, 26},	//39 QTest::mouseDClick(QWidget*, Qt::MouseButton, Qt::KeyboardModifiers, QPoint)
	{29, 101, 98, 3, Smoke::mf_static, 0, 27},	//40 QTest::mouseDClick(QWidget*, Qt::MouseButton, Qt::KeyboardModifiers)
	{29, 101, 95, 2, Smoke::mf_static, 0, 28},	//41 QTest::mouseDClick(QWidget*, Qt::MouseButton)
	{29, 109, 79, 3, Smoke::mf_static, 0, 29},	//42 QTest::mouseMove(QWidget*, QPoint, int)
	{29, 109, 76, 2, Smoke::mf_static, 0, 30},	//43 QTest::mouseMove(QWidget*, QPoint)
	{29, 109, 74, 1, Smoke::mf_static, 0, 31},	//44 QTest::mouseMove(QWidget*)
	{29, 176, 212, 2, Smoke::mf_static, 271, 32},	//45 QTest::toHexRepresentation(const char*, int)
	{29, 178, 185, 1, Smoke::mf_static, 271, 33},	//46 QTest::toString(const char*)
	{29, 178, 215, 1, Smoke::mf_static, 271, 34},	//47 QTest::toString(const void*)
	{29, 133, 249, 3, Smoke::mf_static, 284, 35},	//48 QTest::qExec(QObject*, int, char**)
	{29, 133, 246, 2, Smoke::mf_static, 284, 36},	//49 QTest::qExec(QObject*, int)
	{29, 133, 238, 1, Smoke::mf_static, 284, 37},	//50 QTest::qExec(QObject*)
	{29, 133, 240, 2, Smoke::mf_static, 284, 38},	//51 QTest::qExec(QObject*, const QStringList&)
	{29, 148, 166, 5, Smoke::mf_static, 269, 39},	//52 QTest::qVerify(bool, const char*, const char*, const char*, int)
	{29, 140, 208, 3, Smoke::mf_static, 0, 40},	//53 QTest::qFail(const char*, const char*, int)
	{29, 144, 187, 4, Smoke::mf_static, 0, 41},	//54 QTest::qSkip(const char*, QTest::SkipMode, const char*, int)
	{29, 138, 195, 5, Smoke::mf_static, 269, 42},	//55 QTest::qExpectFail(const char*, const char*, QTest::TestFailMode, const char*, int)
	{29, 152, 185, 1, Smoke::mf_static, 0, 43},	//56 QTest::qWarn(const char*)
	{29, 68, 154, 2, Smoke::mf_static, 0, 44},	//57 QTest::ignoreMessage(QtMsgType, const char*)
	{29, 129, 212, 2, Smoke::mf_static, 285, 45},	//58 QTest::qData(const char*, int)
	{29, 142, 212, 2, Smoke::mf_static, 285, 46},	//59 QTest::qGlobalData(const char*, int)
	{29, 131, 212, 2, Smoke::mf_static, 285, 47},	//60 QTest::qElementData(const char*, int)
	{29, 172, 0, 0, Smoke::mf_static, 93, 48},	//61 QTest::testObject()
	{29, 51, 0, 0, Smoke::mf_static, 282, 49},	//62 QTest::currentTestFunction()
	{29, 49, 0, 0, Smoke::mf_static, 282, 50},	//63 QTest::currentDataTag()
	{29, 50, 0, 0, Smoke::mf_static, 269, 51},	//64 QTest::currentTestFailed()
	{29, 30, 177, 1, Smoke::mf_static, 220, 52},	//65 QTest::asciiToKey(char)
	{29, 93, 152, 1, Smoke::mf_static, 270, 53},	//66 QTest::keyToAscii(Qt::Key)
	{29, 40, 172, 4, Smoke::mf_static, 269, 54},	//67 QTest::compare_helper(bool, const char*, const char*, int)
	{29, 40, 157, 8, Smoke::mf_static, 269, 55},	//68 QTest::compare_helper(bool, const char*, char*, char*, const char*, const char*, const char*, int)
	{29, 146, 224, 1, Smoke::mf_static, 0, 56},	//69 QTest::qSleep(int)
	{29, 26, 226, 2, Smoke::mf_static, 0, 57},	//70 QTest::addColumnInternal(int, const char*)
	{29, 123, 185, 1, Smoke::mf_static, 140, 58},	//71 QTest::newRow(const char*)
	{29, 43, 217, 6, Smoke::mf_static, 269, 59},	//72 QTest::compare_ptr_helper(const void*, const void*, const char*, const char*, const char*, int)
	{29, 45, 201, 6, Smoke::mf_static, 269, 60},	//73 QTest::compare_string_helper(const char*, const char*, const char*, const char*, const char*, int)
	{29, 106, 63, 6, Smoke::mf_static, 0, 61},	//74 QTest::mouseEvent(QTest::MouseAction, QWidget*, Qt::MouseButton, Qt::KeyboardModifiers, QPoint, int)
	{29, 106, 57, 5, Smoke::mf_static, 0, 62},	//75 QTest::mouseEvent(QTest::MouseAction, QWidget*, Qt::MouseButton, Qt::KeyboardModifiers, QPoint)
	{29, 168, 120, 7, Smoke::mf_static, 0, 63},	//76 QTest::simulateEvent(QWidget*, bool, int, Qt::KeyboardModifiers, QString, bool, int)
	{29, 168, 113, 6, Smoke::mf_static, 0, 64},	//77 QTest::simulateEvent(QWidget*, bool, int, Qt::KeyboardModifiers, QString, bool)
	{29, 156, 11, 6, Smoke::mf_static, 0, 65},	//78 QTest::sendKeyEvent(QTest::KeyAction, QWidget*, Qt::Key, QString, Qt::KeyboardModifiers, int)
	{29, 156, 5, 5, Smoke::mf_static, 0, 66},	//79 QTest::sendKeyEvent(QTest::KeyAction, QWidget*, Qt::Key, QString, Qt::KeyboardModifiers)
	{29, 156, 35, 6, Smoke::mf_static, 0, 67},	//80 QTest::sendKeyEvent(QTest::KeyAction, QWidget*, Qt::Key, char, Qt::KeyboardModifiers, int)
	{29, 156, 29, 5, Smoke::mf_static, 0, 68},	//81 QTest::sendKeyEvent(QTest::KeyAction, QWidget*, Qt::Key, char, Qt::KeyboardModifiers)
	{29, 81, 51, 5, Smoke::mf_static, 0, 69},	//82 QTest::keyEvent(QTest::KeyAction, QWidget*, char, Qt::KeyboardModifiers, int)
	{29, 81, 46, 4, Smoke::mf_static, 0, 70},	//83 QTest::keyEvent(QTest::KeyAction, QWidget*, char, Qt::KeyboardModifiers)
	{29, 81, 42, 3, Smoke::mf_static, 0, 71},	//84 QTest::keyEvent(QTest::KeyAction, QWidget*, char)
	{29, 81, 23, 5, Smoke::mf_static, 0, 72},	//85 QTest::keyEvent(QTest::KeyAction, QWidget*, Qt::Key, Qt::KeyboardModifiers, int)
	{29, 81, 18, 4, Smoke::mf_static, 0, 73},	//86 QTest::keyEvent(QTest::KeyAction, QWidget*, Qt::Key, Qt::KeyboardModifiers)
	{29, 81, 1, 3, Smoke::mf_static, 0, 74},	//87 QTest::keyEvent(QTest::KeyAction, QWidget*, Qt::Key)
	{29, 77, 147, 4, Smoke::mf_static, 0, 75},	//88 QTest::keyClicks(QWidget*, const QString&, Qt::KeyboardModifiers, int)
	{29, 77, 143, 3, Smoke::mf_static, 0, 76},	//89 QTest::keyClicks(QWidget*, const QString&, Qt::KeyboardModifiers)
	{29, 77, 140, 2, Smoke::mf_static, 0, 77},	//90 QTest::keyClicks(QWidget*, const QString&)
	{29, 85, 135, 4, Smoke::mf_static, 0, 78},	//91 QTest::keyPress(QWidget*, char, Qt::KeyboardModifiers, int)
	{29, 85, 131, 3, Smoke::mf_static, 0, 79},	//92 QTest::keyPress(QWidget*, char, Qt::KeyboardModifiers)
	{29, 85, 128, 2, Smoke::mf_static, 0, 80},	//93 QTest::keyPress(QWidget*, char)
	{29, 89, 135, 4, Smoke::mf_static, 0, 81},	//94 QTest::keyRelease(QWidget*, char, Qt::KeyboardModifiers, int)
	{29, 89, 131, 3, Smoke::mf_static, 0, 82},	//95 QTest::keyRelease(QWidget*, char, Qt::KeyboardModifiers)
	{29, 89, 128, 2, Smoke::mf_static, 0, 83},	//96 QTest::keyRelease(QWidget*, char)
	{29, 73, 135, 4, Smoke::mf_static, 0, 84},	//97 QTest::keyClick(QWidget*, char, Qt::KeyboardModifiers, int)
	{29, 73, 131, 3, Smoke::mf_static, 0, 85},	//98 QTest::keyClick(QWidget*, char, Qt::KeyboardModifiers)
	{29, 73, 128, 2, Smoke::mf_static, 0, 86},	//99 QTest::keyClick(QWidget*, char)
	{29, 85, 90, 4, Smoke::mf_static, 0, 87},	//100 QTest::keyPress(QWidget*, Qt::Key, Qt::KeyboardModifiers, int)
	{29, 85, 86, 3, Smoke::mf_static, 0, 88},	//101 QTest::keyPress(QWidget*, Qt::Key, Qt::KeyboardModifiers)
	{29, 85, 83, 2, Smoke::mf_static, 0, 89},	//102 QTest::keyPress(QWidget*, Qt::Key)
	{29, 89, 90, 4, Smoke::mf_static, 0, 90},	//103 QTest::keyRelease(QWidget*, Qt::Key, Qt::KeyboardModifiers, int)
	{29, 89, 86, 3, Smoke::mf_static, 0, 91},	//104 QTest::keyRelease(QWidget*, Qt::Key, Qt::KeyboardModifiers)
	{29, 89, 83, 2, Smoke::mf_static, 0, 92},	//105 QTest::keyRelease(QWidget*, Qt::Key)
	{29, 73, 90, 4, Smoke::mf_static, 0, 93},	//106 QTest::keyClick(QWidget*, Qt::Key, Qt::KeyboardModifiers, int)
	{29, 73, 86, 3, Smoke::mf_static, 0, 94},	//107 QTest::keyClick(QWidget*, Qt::Key, Qt::KeyboardModifiers)
	{29, 73, 83, 2, Smoke::mf_static, 0, 95},	//108 QTest::keyClick(QWidget*, Qt::Key)
	{29, 150, 224, 1, Smoke::mf_static, 0, 96},	//109 QTest::qWait(int)
	{30, 70, 0, 0, Smoke::mf_static, 0, 1},	//110 QTestAccessibility::initialize()
	{30, 37, 0, 0, Smoke::mf_static, 0, 2},	//111 QTestAccessibility::cleanup()
	{30, 38, 0, 0, Smoke::mf_static, 0, 3},	//112 QTestAccessibility::clearEvents()
	{30, 66, 0, 0, Smoke::mf_static, 75, 4},	//113 QTestAccessibility::events()
	{30, 184, 179, 1, Smoke::mf_static, 269, 5},	//114 QTestAccessibility::verifyEvent(const QTestAccessibilityEvent&)
	{30, 184, 253, 3, Smoke::mf_static, 269, 6},	//115 QTestAccessibility::verifyEvent(QObject*, int, int)
	{31, 12, 253, 3, Smoke::mf_ctor, 139, 4},	//116 QTestAccessibilityEvent::QTestAccessibilityEvent(QObject*, int, int)
	{31, 12, 246, 2, Smoke::mf_ctor, 139, 5},	//117 QTestAccessibilityEvent::QTestAccessibilityEvent(QObject*, int)
	{31, 12, 238, 1, Smoke::mf_ctor, 139, 6},	//118 QTestAccessibilityEvent::QTestAccessibilityEvent(QObject*)
	{31, 12, 0, 0, Smoke::mf_ctor, 139, 7},	//119 QTestAccessibilityEvent::QTestAccessibilityEvent()
	{31, 126, 179, 1, Smoke::mf_const, 269, 8},	//120 QTestAccessibilityEvent::operator==(const QTestAccessibilityEvent&) const
	{31, 163, 238, 1, 0, 0, 9},	//121 QTestAccessibilityEvent::setObject(QObject*)
	{31, 159, 224, 1, 0, 0, 10},	//122 QTestAccessibilityEvent::setChild(int)
	{31, 161, 224, 1, 0, 0, 11},	//123 QTestAccessibilityEvent::setEvent(int)
	{31, 188, 0, 0, Smoke::mf_dtor, 0, 13},	//124 QTestAccessibilityEvent::~QTestAccessibilityEvent()
	{31, 12, 179, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 139, 12},	//125 QTestAccessibilityEvent::QTestAccessibilityEvent(const QTestAccessibilityEvent&)
	{31, 125, 0, 0, 0, 93, 1},	//126 QTestAccessibilityEvent::object (var)
	{31, 34, 0, 0, 0, 284, 2},	//127 QTestAccessibilityEvent::child (var)
	{31, 62, 0, 0, 0, 284, 3},	//128 QTestAccessibilityEvent::event (var)
	{32, 28, 229, 2, 0, 0, 1},	//129 QTestData::append(int, const void*)
	{32, 54, 224, 1, Smoke::mf_const, 285, 2},	//130 QTestData::data(int) const
	{32, 57, 0, 0, Smoke::mf_const, 282, 3},	//131 QTestData::dataTag() const
	{32, 128, 0, 0, Smoke::mf_const, 145, 4},	//132 QTestData::parent() const
	{32, 56, 0, 0, Smoke::mf_const, 284, 5},	//133 QTestData::dataCount() const
	{33, 16, 224, 1, Smoke::mf_ctor, 141, 1},	//134 QTestDelayEvent::QTestDelayEvent(int)
	{33, 39, 0, 0, Smoke::mf_const, 142, 2},	//135 QTestDelayEvent::clone() const
	{33, 166, 74, 1, 0, 0, 3},	//136 QTestDelayEvent::simulate(QWidget*)
	{33, 190, 0, 0, Smoke::mf_dtor, 0, 5},	//137 QTestDelayEvent::~QTestDelayEvent()
	{33, 16, 181, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 141, 4},	//138 QTestDelayEvent::QTestDelayEvent(const QTestDelayEvent&)
	{34, 166, 74, 1, 0, 0, 1},	//139 QTestEvent::simulate(QWidget*) [pure virtual]
	{34, 39, 0, 0, Smoke::mf_const, 142, 2},	//140 QTestEvent::clone() const [pure virtual]
	{34, 191, 0, 0, Smoke::mf_dtor, 0, 5},	//141 QTestEvent::~QTestEvent()
	{34, 19, 0, 0, Smoke::mf_ctor, 142, 3},	//142 QTestEvent::QTestEvent()
	{34, 19, 183, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 142, 4},	//143 QTestEvent::QTestEvent(const QTestEvent&)
	{35, 95, 0, 0, Smoke::mf_const, 275, 2},	//144 QTestEventLoop::metaObject() const
	{35, 154, 234, 3, 0, 284, 3},	//145 QTestEventLoop::qt_metacall(QMetaObject::Call, int, void**)
	{35, 21, 238, 1, Smoke::mf_ctor, 144, 4},	//146 QTestEventLoop::QTestEventLoop(QObject*)
	{35, 21, 0, 0, Smoke::mf_ctor, 144, 5},	//147 QTestEventLoop::QTestEventLoop()
	{35, 60, 224, 1, 0, 0, 6},	//148 QTestEventLoop::enterLoop(int)
	{35, 32, 224, 1, 0, 0, 7},	//149 QTestEventLoop::changeInterval(int)
	{35, 173, 0, 0, Smoke::mf_const, 269, 8},	//150 QTestEventLoop::timeout() const
	{35, 192, 0, 0, Smoke::mf_dtor, 0, 14},	//151 QTestEventLoop::~QTestEventLoop()
	{35, 67, 0, 0, 0, 0, 9},	//152 QTestEventLoop::exitLoop()
	{35, 181, 192, 2, Smoke::mf_static, 112, 10},	//153 QTestEventLoop::tr(const char*, const char*)
	{35, 181, 185, 1, Smoke::mf_static, 112, 11},	//154 QTestEventLoop::tr(const char*)
	{35, 71, 0, 0, Smoke::mf_static, 143, 12},	//155 QTestEventLoop::instance()
	{35, 171, 0, 0, Smoke::mf_static, 274, 1},	//156 QTestEventLoop::staticMetaObject (static var)
	{35, 174, 72, 1, Smoke::mf_protected, 0, 13},	//157 QTestEventLoop::timerEvent(QTimerEvent*)
};

// Class ID, munged name ID (index into methodNames), method def (see methods) if >0 or number of overloads if <0
static Smoke::MethodMap qttest_methodMaps[] = {
	{ 0, 0, 0 },	//0 (no method)
	{25, 11, 9},	//1 QSignalSpy::QSignalSpy#$
	{25, 72, 10},	//2 QSignalSpy::isValid
	{25, 155, 12},	//3 QSignalSpy::qt_metacall$$?
	{25, 165, 11},	//4 QSignalSpy::signal
	{25, 187, 13},	//5 QSignalSpy::~QSignalSpy
	{29, 1, 24},	//6 QTest::Abort
	{29, 2, 21},	//7 QTest::Click
	{29, 3, 25},	//8 QTest::Continue
	{29, 4, 16},	//9 QTest::MouseClick
	{29, 5, 17},	//10 QTest::MouseDClick
	{29, 6, 18},	//11 QTest::MouseMove
	{29, 7, 14},	//12 QTest::MousePress
	{29, 8, 15},	//13 QTest::MouseRelease
	{29, 9, 19},	//14 QTest::Press
	{29, 23, 20},	//15 QTest::Release
	{29, 24, 23},	//16 QTest::SkipAll
	{29, 25, 22},	//17 QTest::SkipSingle
	{29, 27, 70},	//18 QTest::addColumnInternal$$
	{29, 31, 65},	//19 QTest::asciiToKey$
	{29, 41, 67},	//20 QTest::compare_helper$$$$
	{29, 42, 68},	//21 QTest::compare_helper$$$$$$$$
	{29, 44, 72},	//22 QTest::compare_ptr_helper??$$$$
	{29, 46, 73},	//23 QTest::compare_string_helper$$$$$$
	{29, 49, 63},	//24 QTest::currentDataTag
	{29, 50, 64},	//25 QTest::currentTestFailed
	{29, 51, 62},	//26 QTest::currentTestFunction
	{29, 69, 57},	//27 QTest::ignoreMessage?$
	{29, 74, -1},	//28 QTest::keyClick#$
	{29, 75, -4},	//29 QTest::keyClick#$$
	{29, 76, -7},	//30 QTest::keyClick#$$$
	{29, 78, 90},	//31 QTest::keyClicks#$
	{29, 79, 89},	//32 QTest::keyClicks#$$
	{29, 80, 88},	//33 QTest::keyClicks#$$$
	{29, 82, -10},	//34 QTest::keyEvent$#$
	{29, 83, -13},	//35 QTest::keyEvent$#$$
	{29, 84, -16},	//36 QTest::keyEvent$#$$$
	{29, 86, -19},	//37 QTest::keyPress#$
	{29, 87, -22},	//38 QTest::keyPress#$$
	{29, 88, -25},	//39 QTest::keyPress#$$$
	{29, 90, -28},	//40 QTest::keyRelease#$
	{29, 91, -31},	//41 QTest::keyRelease#$$
	{29, 92, -34},	//42 QTest::keyRelease#$$$
	{29, 94, 66},	//43 QTest::keyToAscii$
	{29, 97, 37},	//44 QTest::mouseClick#$
	{29, 98, 36},	//45 QTest::mouseClick#$$
	{29, 99, 35},	//46 QTest::mouseClick#$$#
	{29, 100, 34},	//47 QTest::mouseClick#$$#$
	{29, 102, 41},	//48 QTest::mouseDClick#$
	{29, 103, 40},	//49 QTest::mouseDClick#$$
	{29, 104, 39},	//50 QTest::mouseDClick#$$#
	{29, 105, 38},	//51 QTest::mouseDClick#$$#$
	{29, 107, 75},	//52 QTest::mouseEvent$#$$#
	{29, 108, 74},	//53 QTest::mouseEvent$#$$#$
	{29, 110, 44},	//54 QTest::mouseMove#
	{29, 111, 43},	//55 QTest::mouseMove##
	{29, 112, 42},	//56 QTest::mouseMove##$
	{29, 114, 29},	//57 QTest::mousePress#$
	{29, 115, 28},	//58 QTest::mousePress#$$
	{29, 116, 27},	//59 QTest::mousePress#$$#
	{29, 117, 26},	//60 QTest::mousePress#$$#$
	{29, 119, 33},	//61 QTest::mouseRelease#$
	{29, 120, 32},	//62 QTest::mouseRelease#$$
	{29, 121, 31},	//63 QTest::mouseRelease#$$#
	{29, 122, 30},	//64 QTest::mouseRelease#$$#$
	{29, 124, 71},	//65 QTest::newRow$
	{29, 130, 58},	//66 QTest::qData$$
	{29, 132, 60},	//67 QTest::qElementData$$
	{29, 134, 50},	//68 QTest::qExec#
	{29, 135, 49},	//69 QTest::qExec#$
	{29, 136, 48},	//70 QTest::qExec#$?
	{29, 137, 51},	//71 QTest::qExec#?
	{29, 139, 55},	//72 QTest::qExpectFail$$$$$
	{29, 141, 53},	//73 QTest::qFail$$$
	{29, 143, 59},	//74 QTest::qGlobalData$$
	{29, 145, 54},	//75 QTest::qSkip$$$$
	{29, 147, 69},	//76 QTest::qSleep$
	{29, 149, 52},	//77 QTest::qVerify$$$$$
	{29, 151, 109},	//78 QTest::qWait$
	{29, 153, 56},	//79 QTest::qWarn$
	{29, 157, -37},	//80 QTest::sendKeyEvent$#$$$
	{29, 158, -40},	//81 QTest::sendKeyEvent$#$$$$
	{29, 169, 77},	//82 QTest::simulateEvent#$$$$$
	{29, 170, 76},	//83 QTest::simulateEvent#$$$$$$
	{29, 172, 61},	//84 QTest::testObject
	{29, 177, 45},	//85 QTest::toHexRepresentation$$
	{29, 179, 46},	//86 QTest::toString$
	{29, 180, 47},	//87 QTest::toString?
	{30, 37, 111},	//88 QTestAccessibility::cleanup
	{30, 38, 112},	//89 QTestAccessibility::clearEvents
	{30, 66, 113},	//90 QTestAccessibility::events
	{30, 70, 110},	//91 QTestAccessibility::initialize
	{30, 185, 114},	//92 QTestAccessibility::verifyEvent#
	{30, 186, 115},	//93 QTestAccessibility::verifyEvent#$$
	{31, 12, 119},	//94 QTestAccessibilityEvent::QTestAccessibilityEvent
	{31, 13, -43},	//95 QTestAccessibilityEvent::QTestAccessibilityEvent#
	{31, 14, 117},	//96 QTestAccessibilityEvent::QTestAccessibilityEvent#$
	{31, 15, 116},	//97 QTestAccessibilityEvent::QTestAccessibilityEvent#$$
	{31, 34, 127},	//98 QTestAccessibilityEvent::child
	{31, 62, 128},	//99 QTestAccessibilityEvent::event
	{31, 125, 126},	//100 QTestAccessibilityEvent::object
	{31, 127, 120},	//101 QTestAccessibilityEvent::operator==#
	{31, 160, 122},	//102 QTestAccessibilityEvent::setChild$
	{31, 162, 123},	//103 QTestAccessibilityEvent::setEvent$
	{31, 164, 121},	//104 QTestAccessibilityEvent::setObject#
	{31, 188, 124},	//105 QTestAccessibilityEvent::~QTestAccessibilityEvent
	{32, 29, 129},	//106 QTestData::append$?
	{32, 55, 130},	//107 QTestData::data$
	{32, 56, 133},	//108 QTestData::dataCount
	{32, 57, 131},	//109 QTestData::dataTag
	{32, 128, 132},	//110 QTestData::parent
	{33, 17, 138},	//111 QTestDelayEvent::QTestDelayEvent#
	{33, 18, 134},	//112 QTestDelayEvent::QTestDelayEvent$
	{33, 39, 135},	//113 QTestDelayEvent::clone
	{33, 167, 136},	//114 QTestDelayEvent::simulate#
	{33, 190, 137},	//115 QTestDelayEvent::~QTestDelayEvent
	{34, 19, 142},	//116 QTestEvent::QTestEvent
	{34, 20, 143},	//117 QTestEvent::QTestEvent#
	{34, 39, 140},	//118 QTestEvent::clone
	{34, 167, 139},	//119 QTestEvent::simulate#
	{34, 191, 141},	//120 QTestEvent::~QTestEvent
	{35, 21, 147},	//121 QTestEventLoop::QTestEventLoop
	{35, 22, 146},	//122 QTestEventLoop::QTestEventLoop#
	{35, 33, 149},	//123 QTestEventLoop::changeInterval$
	{35, 61, 148},	//124 QTestEventLoop::enterLoop$
	{35, 67, 152},	//125 QTestEventLoop::exitLoop
	{35, 71, 155},	//126 QTestEventLoop::instance
	{35, 95, 144},	//127 QTestEventLoop::metaObject
	{35, 155, 145},	//128 QTestEventLoop::qt_metacall$$?
	{35, 171, 156},	//129 QTestEventLoop::staticMetaObject
	{35, 173, 150},	//130 QTestEventLoop::timeout
	{35, 175, 157},	//131 QTestEventLoop::timerEvent#
	{35, 182, 154},	//132 QTestEventLoop::tr$
	{35, 183, 153},	//133 QTestEventLoop::tr$$
	{35, 192, 151},	//134 QTestEventLoop::~QTestEventLoop
};

static Smoke::Index qttest_ambiguousMethodList[] = {
    0,
    108,  // QTest::keyClick(QWidget*, Qt::Key)
    99,  // QTest::keyClick(QWidget*, char)
    0,
    98,  // QTest::keyClick(QWidget*, char, Qt::KeyboardModifiers)
    107,  // QTest::keyClick(QWidget*, Qt::Key, Qt::KeyboardModifiers)
    0,
    97,  // QTest::keyClick(QWidget*, char, Qt::KeyboardModifiers, int)
    106,  // QTest::keyClick(QWidget*, Qt::Key, Qt::KeyboardModifiers, int)
    0,
    84,  // QTest::keyEvent(QTest::KeyAction, QWidget*, char)
    87,  // QTest::keyEvent(QTest::KeyAction, QWidget*, Qt::Key)
    0,
    83,  // QTest::keyEvent(QTest::KeyAction, QWidget*, char, Qt::KeyboardModifiers)
    86,  // QTest::keyEvent(QTest::KeyAction, QWidget*, Qt::Key, Qt::KeyboardModifiers)
    0,
    85,  // QTest::keyEvent(QTest::KeyAction, QWidget*, Qt::Key, Qt::KeyboardModifiers, int)
    82,  // QTest::keyEvent(QTest::KeyAction, QWidget*, char, Qt::KeyboardModifiers, int)
    0,
    93,  // QTest::keyPress(QWidget*, char)
    102,  // QTest::keyPress(QWidget*, Qt::Key)
    0,
    92,  // QTest::keyPress(QWidget*, char, Qt::KeyboardModifiers)
    101,  // QTest::keyPress(QWidget*, Qt::Key, Qt::KeyboardModifiers)
    0,
    91,  // QTest::keyPress(QWidget*, char, Qt::KeyboardModifiers, int)
    100,  // QTest::keyPress(QWidget*, Qt::Key, Qt::KeyboardModifiers, int)
    0,
    105,  // QTest::keyRelease(QWidget*, Qt::Key)
    96,  // QTest::keyRelease(QWidget*, char)
    0,
    95,  // QTest::keyRelease(QWidget*, char, Qt::KeyboardModifiers)
    104,  // QTest::keyRelease(QWidget*, Qt::Key, Qt::KeyboardModifiers)
    0,
    94,  // QTest::keyRelease(QWidget*, char, Qt::KeyboardModifiers, int)
    103,  // QTest::keyRelease(QWidget*, Qt::Key, Qt::KeyboardModifiers, int)
    0,
    79,  // QTest::sendKeyEvent(QTest::KeyAction, QWidget*, Qt::Key, QString, Qt::KeyboardModifiers)
    81,  // QTest::sendKeyEvent(QTest::KeyAction, QWidget*, Qt::Key, char, Qt::KeyboardModifiers)
    0,
    78,  // QTest::sendKeyEvent(QTest::KeyAction, QWidget*, Qt::Key, QString, Qt::KeyboardModifiers, int)
    80,  // QTest::sendKeyEvent(QTest::KeyAction, QWidget*, Qt::Key, char, Qt::KeyboardModifiers, int)
    0,
    125,  // QTestAccessibilityEvent::QTestAccessibilityEvent(const QTestAccessibilityEvent&)
    118,  // QTestAccessibilityEvent::QTestAccessibilityEvent(QObject*)
    0,
};


void init_qt_Smoke();

static bool initialized = false;
Smoke *qttest_Smoke = 0;

// Create the Smoke instance encapsulating all the above.
void init_qttest_Smoke() {
    if (initialized) return;
    init_qt_Smoke();
    qttest_Smoke = new Smoke(
        "qttest",
        qttest_classes, 40,
        qttest_methods, 158,
        qttest_methodMaps, 134,
        qttest_methodNames, 192,
        qttest_types, 286,
        qttest_inheritanceList,
        qttest_argumentList,
        qttest_ambiguousMethodList,
        qttest_cast );
    initialized = true;
}
