#include <qaction.h>
#include <qactiongroup.h>
#include <qcoreevent.h>
#include <qdir.h>
#include <qevent.h>
#include <qfont.h>
#include <qiodevice.h>
#include <qlayout.h>
#include <qnamespace.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qpalette.h>
#include <qsize.h>
#include <qstyle.h>
#include <quiloader.h>
#include <qvariant.h>
#include <qwidget.h>

#include <smoke.h>

#include <qtuitools_smoke.h>

static void *qtuitools_cast(void *xptr, Smoke::Index from, Smoke::Index to) {
    switch(from) {
      case 1:	//QAction
	switch(to) {
	    case 23: return (void*)(QObject*)(QAction*)xptr;
	    case 1: return (void*)(QAction*)(QAction*)xptr;
	  default: return xptr;
	}
      case 2:	//QActionEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QActionEvent*)xptr;
	    case 2: return (void*)(QActionEvent*)(QActionEvent*)xptr;
	  default: return xptr;
	}
      case 3:	//QActionGroup
	switch(to) {
	    case 23: return (void*)(QObject*)(QActionGroup*)xptr;
	    case 3: return (void*)(QActionGroup*)(QActionGroup*)xptr;
	  default: return xptr;
	}
      case 4:	//QChildEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QChildEvent*)xptr;
	    case 4: return (void*)(QChildEvent*)(QChildEvent*)xptr;
	  default: return xptr;
	}
      case 5:	//QCloseEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QCloseEvent*)xptr;
	    case 5: return (void*)(QCloseEvent*)(QCloseEvent*)xptr;
	  default: return xptr;
	}
      case 6:	//QContextMenuEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QContextMenuEvent*)xptr;
	    case 6: return (void*)(QContextMenuEvent*)(QContextMenuEvent*)xptr;
	  default: return xptr;
	}
      case 7:	//QDir
	switch(to) {
	    case 7: return (void*)(QDir*)(QDir*)xptr;
	  default: return xptr;
	}
      case 8:	//QDragEnterEvent
	switch(to) {
	    case 10: return (void*)(QDragMoveEvent*)(QDragEnterEvent*)xptr;
	    case 11: return (void*)(QDropEvent*)(QDragEnterEvent*)xptr;
	    case 12: return (void*)(QEvent*)(QDragEnterEvent*)xptr;
	    case 8: return (void*)(QDragEnterEvent*)(QDragEnterEvent*)xptr;
	  default: return xptr;
	}
      case 9:	//QDragLeaveEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QDragLeaveEvent*)xptr;
	    case 9: return (void*)(QDragLeaveEvent*)(QDragLeaveEvent*)xptr;
	  default: return xptr;
	}
      case 10:	//QDragMoveEvent
	switch(to) {
	    case 11: return (void*)(QDropEvent*)(QDragMoveEvent*)xptr;
	    case 12: return (void*)(QEvent*)(QDragMoveEvent*)xptr;
	    case 10: return (void*)(QDragMoveEvent*)(QDragMoveEvent*)xptr;
	    case 8: return (void*)(QDragEnterEvent*)(QDragMoveEvent*)xptr;
	  default: return xptr;
	}
      case 11:	//QDropEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QDropEvent*)xptr;
	    case 11: return (void*)(QDropEvent*)(QDropEvent*)xptr;
	    case 8: return (void*)(QDragEnterEvent*)(QDropEvent*)xptr;
	    case 10: return (void*)(QDragMoveEvent*)(QDropEvent*)xptr;
	  default: return xptr;
	}
      case 12:	//QEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QEvent*)xptr;
	    case 2: return (void*)(QActionEvent*)(QEvent*)xptr;
	    case 4: return (void*)(QChildEvent*)(QEvent*)xptr;
	    case 5: return (void*)(QCloseEvent*)(QEvent*)xptr;
	    case 6: return (void*)(QContextMenuEvent*)(QEvent*)xptr;
	    case 8: return (void*)(QDragEnterEvent*)(QEvent*)xptr;
	    case 9: return (void*)(QDragLeaveEvent*)(QEvent*)xptr;
	    case 10: return (void*)(QDragMoveEvent*)(QEvent*)xptr;
	    case 11: return (void*)(QDropEvent*)(QEvent*)xptr;
	    case 13: return (void*)(QFocusEvent*)(QEvent*)xptr;
	    case 15: return (void*)(QHideEvent*)(QEvent*)xptr;
	    case 17: return (void*)(QInputMethodEvent*)(QEvent*)xptr;
	    case 18: return (void*)(QKeyEvent*)(QEvent*)xptr;
	    case 21: return (void*)(QMouseEvent*)(QEvent*)xptr;
	    case 22: return (void*)(QMoveEvent*)(QEvent*)xptr;
	    case 24: return (void*)(QPaintEvent*)(QEvent*)xptr;
	    case 26: return (void*)(QResizeEvent*)(QEvent*)xptr;
	    case 27: return (void*)(QShowEvent*)(QEvent*)xptr;
	    case 30: return (void*)(QTabletEvent*)(QEvent*)xptr;
	    case 31: return (void*)(QTimerEvent*)(QEvent*)xptr;
	    case 34: return (void*)(QWheelEvent*)(QEvent*)xptr;
	  default: return xptr;
	}
      case 13:	//QFocusEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QFocusEvent*)xptr;
	    case 13: return (void*)(QFocusEvent*)(QFocusEvent*)xptr;
	  default: return xptr;
	}
      case 14:	//QFont
	switch(to) {
	    case 14: return (void*)(QFont*)(QFont*)xptr;
	  default: return xptr;
	}
      case 15:	//QHideEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QHideEvent*)xptr;
	    case 15: return (void*)(QHideEvent*)(QHideEvent*)xptr;
	  default: return xptr;
	}
      case 16:	//QIODevice
	switch(to) {
	    case 23: return (void*)(QObject*)(QIODevice*)xptr;
	    case 16: return (void*)(QIODevice*)(QIODevice*)xptr;
	  default: return xptr;
	}
      case 17:	//QInputMethodEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QInputMethodEvent*)xptr;
	    case 17: return (void*)(QInputMethodEvent*)(QInputMethodEvent*)xptr;
	  default: return xptr;
	}
      case 18:	//QKeyEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QKeyEvent*)xptr;
	    case 18: return (void*)(QKeyEvent*)(QKeyEvent*)xptr;
	  default: return xptr;
	}
      case 19:	//QLayout
	switch(to) {
	    case 23: return (void*)(QObject*)(QLayout*)xptr;
	    case 19: return (void*)(QLayout*)(QLayout*)xptr;
	  default: return xptr;
	}
      case 20:	//QMetaObject
	switch(to) {
	    case 20: return (void*)(QMetaObject*)(QMetaObject*)xptr;
	  default: return xptr;
	}
      case 21:	//QMouseEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QMouseEvent*)xptr;
	    case 21: return (void*)(QMouseEvent*)(QMouseEvent*)xptr;
	  default: return xptr;
	}
      case 22:	//QMoveEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QMoveEvent*)xptr;
	    case 22: return (void*)(QMoveEvent*)(QMoveEvent*)xptr;
	  default: return xptr;
	}
      case 23:	//QObject
	switch(to) {
	    case 23: return (void*)(QObject*)(QObject*)xptr;
	    case 1: return (void*)(QAction*)(QObject*)xptr;
	    case 3: return (void*)(QActionGroup*)(QObject*)xptr;
	    case 16: return (void*)(QIODevice*)(QObject*)xptr;
	    case 19: return (void*)(QLayout*)(QObject*)xptr;
	    case 29: return (void*)(QStyle*)(QObject*)xptr;
	    case 32: return (void*)(QUiLoader*)(QObject*)xptr;
	    case 35: return (void*)(QWidget*)(QObject*)xptr;
	  default: return xptr;
	}
      case 24:	//QPaintEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QPaintEvent*)xptr;
	    case 24: return (void*)(QPaintEvent*)(QPaintEvent*)xptr;
	  default: return xptr;
	}
      case 25:	//QPalette
	switch(to) {
	    case 25: return (void*)(QPalette*)(QPalette*)xptr;
	  default: return xptr;
	}
      case 26:	//QResizeEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QResizeEvent*)xptr;
	    case 26: return (void*)(QResizeEvent*)(QResizeEvent*)xptr;
	  default: return xptr;
	}
      case 27:	//QShowEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QShowEvent*)xptr;
	    case 27: return (void*)(QShowEvent*)(QShowEvent*)xptr;
	  default: return xptr;
	}
      case 28:	//QSize
	switch(to) {
	    case 28: return (void*)(QSize*)(QSize*)xptr;
	  default: return xptr;
	}
      case 29:	//QStyle
	switch(to) {
	    case 23: return (void*)(QObject*)(QStyle*)xptr;
	    case 29: return (void*)(QStyle*)(QStyle*)xptr;
	  default: return xptr;
	}
      case 30:	//QTabletEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QTabletEvent*)xptr;
	    case 30: return (void*)(QTabletEvent*)(QTabletEvent*)xptr;
	  default: return xptr;
	}
      case 31:	//QTimerEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QTimerEvent*)xptr;
	    case 31: return (void*)(QTimerEvent*)(QTimerEvent*)xptr;
	  default: return xptr;
	}
      case 32:	//QUiLoader
	switch(to) {
	    case 23: return (void*)(QObject*)(QUiLoader*)xptr;
	    case 32: return (void*)(QUiLoader*)(QUiLoader*)xptr;
	  default: return xptr;
	}
      case 33:	//QVariant
	switch(to) {
	    case 33: return (void*)(QVariant*)(QVariant*)xptr;
	  default: return xptr;
	}
      case 34:	//QWheelEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QWheelEvent*)xptr;
	    case 34: return (void*)(QWheelEvent*)(QWheelEvent*)xptr;
	  default: return xptr;
	}
      case 35:	//QWidget
	switch(to) {
	    case 23: return (void*)(QObject*)(QWidget*)xptr;
	    case 35: return (void*)(QWidget*)(QWidget*)xptr;
	  default: return xptr;
	}
      default: return xptr;
    }
}

// Group of Indexes (0 separated) used as super class lists.
// Classes with super classes have an index into this array.
static Smoke::Index qtuitools_inheritanceList[] = {
	0,	// 0: (no super class)
	23, 0,	// 1: QObject
};

// These are the xenum functions for manipulating enum pointers

// Those are the xcall functions defined in each x_*.cpp file, for dispatching method calls
void xcall_QUiLoader(Smoke::Index, void*, Smoke::Stack);

// List of all classes
// Name, index into inheritanceList, method dispatcher, enum dispatcher, class flags
static Smoke::Class qtuitools_classes[] = {
	{ 0L, false, 0, 0, 0, 0 }, 	// 0 (no class)
	{ "QAction", true, 0, 0, 0, 0 }, 	// 1
	{ "QActionEvent", true, 0, 0, 0, 0 }, 	// 2
	{ "QActionGroup", true, 0, 0, 0, 0 }, 	// 3
	{ "QChildEvent", true, 0, 0, 0, 0 }, 	// 4
	{ "QCloseEvent", true, 0, 0, 0, 0 }, 	// 5
	{ "QContextMenuEvent", true, 0, 0, 0, 0 }, 	// 6
	{ "QDir", true, 0, 0, 0, 0 }, 	// 7
	{ "QDragEnterEvent", true, 0, 0, 0, 0 }, 	// 8
	{ "QDragLeaveEvent", true, 0, 0, 0, 0 }, 	// 9
	{ "QDragMoveEvent", true, 0, 0, 0, 0 }, 	// 10
	{ "QDropEvent", true, 0, 0, 0, 0 }, 	// 11
	{ "QEvent", true, 0, 0, 0, 0 }, 	// 12
	{ "QFocusEvent", true, 0, 0, 0, 0 }, 	// 13
	{ "QFont", true, 0, 0, 0, 0 }, 	// 14
	{ "QHideEvent", true, 0, 0, 0, 0 }, 	// 15
	{ "QIODevice", true, 0, 0, 0, 0 }, 	// 16
	{ "QInputMethodEvent", true, 0, 0, 0, 0 }, 	// 17
	{ "QKeyEvent", true, 0, 0, 0, 0 }, 	// 18
	{ "QLayout", true, 0, 0, 0, 0 }, 	// 19
	{ "QMetaObject", true, 0, 0, 0, 0 }, 	// 20
	{ "QMouseEvent", true, 0, 0, 0, 0 }, 	// 21
	{ "QMoveEvent", true, 0, 0, 0, 0 }, 	// 22
	{ "QObject", true, 0, 0, 0, 0 }, 	// 23
	{ "QPaintEvent", true, 0, 0, 0, 0 }, 	// 24
	{ "QPalette", true, 0, 0, 0, 0 }, 	// 25
	{ "QResizeEvent", true, 0, 0, 0, 0 }, 	// 26
	{ "QShowEvent", true, 0, 0, 0, 0 }, 	// 27
	{ "QSize", true, 0, 0, 0, 0 }, 	// 28
	{ "QStyle", true, 0, 0, 0, 0 }, 	// 29
	{ "QTabletEvent", true, 0, 0, 0, 0 }, 	// 30
	{ "QTimerEvent", true, 0, 0, 0, 0 }, 	// 31
	{ "QUiLoader", false, 1, xcall_QUiLoader, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//32
	{ "QVariant", true, 0, 0, 0, 0 }, 	// 33
	{ "QWheelEvent", true, 0, 0, 0, 0 }, 	// 34
	{ "QWidget", true, 0, 0, 0, 0 }, 	// 35
	{ "Qt", true, 0, 0, 0, 0 }, 	// 36
};

// List of all types needed by the methods (arguments and return values)
// Name, class ID if arg is a class, and TypeId
static Smoke::Type qtuitools_types[] = {
	{ 0, 0, 0 },	//0 (no type)
	{ "QAbstractFileEngine::FileFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//1
	{ "QAbstractFileEngine::FileFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//2
	{ "QAbstractItemView::EditTriggers", 0, Smoke::t_uint | Smoke::tf_stack },	//3
	{ "QAbstractItemView::EditTriggers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//4
	{ "QAbstractPrintDialog::PrintDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//5
	{ "QAbstractPrintDialog::PrintDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//6
	{ "QAbstractSpinBox::StepEnabled", 0, Smoke::t_uint | Smoke::tf_stack },	//7
	{ "QAbstractSpinBox::StepEnabled&", 0, Smoke::t_voidp | Smoke::tf_ref },	//8
	{ "QAccessible::Relation", 0, Smoke::t_uint | Smoke::tf_stack },	//9
	{ "QAccessible::Relation&", 0, Smoke::t_voidp | Smoke::tf_ref },	//10
	{ "QAccessible::State", 0, Smoke::t_uint | Smoke::tf_stack },	//11
	{ "QAccessible::State&", 0, Smoke::t_voidp | Smoke::tf_ref },	//12
	{ "QAction*", 1, Smoke::t_class | Smoke::tf_ptr },	//13
	{ "QActionEvent*", 2, Smoke::t_class | Smoke::tf_ptr },	//14
	{ "QActionGroup*", 3, Smoke::t_class | Smoke::tf_ptr },	//15
	{ "QChildEvent*", 4, Smoke::t_class | Smoke::tf_ptr },	//16
	{ "QCloseEvent*", 5, Smoke::t_class | Smoke::tf_ptr },	//17
	{ "QColorDialog::ColorDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//18
	{ "QColorDialog::ColorDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//19
	{ "QContextMenuEvent*", 6, Smoke::t_class | Smoke::tf_ptr },	//20
	{ "QDBusConnection::RegisterOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//21
	{ "QDBusConnection::RegisterOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//22
	{ "QDateTimeEdit::Sections", 0, Smoke::t_uint | Smoke::tf_stack },	//23
	{ "QDateTimeEdit::Sections&", 0, Smoke::t_voidp | Smoke::tf_ref },	//24
	{ "QDialogButtonBox::StandardButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//25
	{ "QDialogButtonBox::StandardButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//26
	{ "QDir", 7, Smoke::t_class | Smoke::tf_stack },	//27
	{ "QDir::Filters", 0, Smoke::t_uint | Smoke::tf_stack },	//28
	{ "QDir::Filters&", 0, Smoke::t_voidp | Smoke::tf_ref },	//29
	{ "QDir::SortFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//30
	{ "QDir::SortFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//31
	{ "QDirIterator::IteratorFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//32
	{ "QDirIterator::IteratorFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//33
	{ "QDockWidget::DockWidgetFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//34
	{ "QDockWidget::DockWidgetFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//35
	{ "QDragEnterEvent*", 8, Smoke::t_class | Smoke::tf_ptr },	//36
	{ "QDragLeaveEvent*", 9, Smoke::t_class | Smoke::tf_ptr },	//37
	{ "QDragMoveEvent*", 10, Smoke::t_class | Smoke::tf_ptr },	//38
	{ "QDropEvent*", 11, Smoke::t_class | Smoke::tf_ptr },	//39
	{ "QEvent*", 12, Smoke::t_class | Smoke::tf_ptr },	//40
	{ "QEventLoop::ProcessEventsFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//41
	{ "QEventLoop::ProcessEventsFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//42
	{ "QFile::Permissions", 0, Smoke::t_uint | Smoke::tf_stack },	//43
	{ "QFile::Permissions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//44
	{ "QFileDialog::Options", 0, Smoke::t_uint | Smoke::tf_stack },	//45
	{ "QFileDialog::Options&", 0, Smoke::t_voidp | Smoke::tf_ref },	//46
	{ "QFocusEvent*", 13, Smoke::t_class | Smoke::tf_ptr },	//47
	{ "QFontComboBox::FontFilters", 0, Smoke::t_uint | Smoke::tf_stack },	//48
	{ "QFontComboBox::FontFilters&", 0, Smoke::t_voidp | Smoke::tf_ref },	//49
	{ "QFontDialog::FontDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//50
	{ "QFontDialog::FontDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//51
	{ "QGL::FormatOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//52
	{ "QGL::FormatOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//53
	{ "QGLFormat::OpenGLVersionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//54
	{ "QGLFormat::OpenGLVersionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//55
	{ "QGraphicsItem::GraphicsItemFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//56
	{ "QGraphicsItem::GraphicsItemFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//57
	{ "QGraphicsScene::SceneLayers", 0, Smoke::t_uint | Smoke::tf_stack },	//58
	{ "QGraphicsScene::SceneLayers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//59
	{ "QGraphicsView::CacheMode", 0, Smoke::t_uint | Smoke::tf_stack },	//60
	{ "QGraphicsView::CacheMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//61
	{ "QGraphicsView::OptimizationFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//62
	{ "QGraphicsView::OptimizationFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//63
	{ "QHideEvent*", 15, Smoke::t_class | Smoke::tf_ptr },	//64
	{ "QIODevice*", 16, Smoke::t_class | Smoke::tf_ptr },	//65
	{ "QIODevice::OpenMode", 0, Smoke::t_uint | Smoke::tf_stack },	//66
	{ "QIODevice::OpenMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//67
	{ "QImageIOPlugin::Capabilities", 0, Smoke::t_uint | Smoke::tf_stack },	//68
	{ "QImageIOPlugin::Capabilities&", 0, Smoke::t_voidp | Smoke::tf_ref },	//69
	{ "QInputDialog::InputDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//70
	{ "QInputDialog::InputDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//71
	{ "QInputMethodEvent*", 17, Smoke::t_class | Smoke::tf_ptr },	//72
	{ "QItemSelectionModel::SelectionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//73
	{ "QItemSelectionModel::SelectionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//74
	{ "QKeyEvent*", 18, Smoke::t_class | Smoke::tf_ptr },	//75
	{ "QLayout*", 19, Smoke::t_class | Smoke::tf_ptr },	//76
	{ "QLibrary::LoadHints", 0, Smoke::t_uint | Smoke::tf_stack },	//77
	{ "QLibrary::LoadHints&", 0, Smoke::t_voidp | Smoke::tf_ref },	//78
	{ "QLocale::NumberOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//79
	{ "QLocale::NumberOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//80
	{ "QMainWindow::DockOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//81
	{ "QMainWindow::DockOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//82
	{ "QMdiArea::AreaOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//83
	{ "QMdiArea::AreaOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//84
	{ "QMdiSubWindow::SubWindowOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//85
	{ "QMdiSubWindow::SubWindowOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//86
	{ "QMessageBox::StandardButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//87
	{ "QMessageBox::StandardButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//88
	{ "QMetaObject::Call", 20, Smoke::t_enum | Smoke::tf_stack },	//89
	{ "QMouseEvent*", 21, Smoke::t_class | Smoke::tf_ptr },	//90
	{ "QMoveEvent*", 22, Smoke::t_class | Smoke::tf_ptr },	//91
	{ "QNetworkInterface::InterfaceFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//92
	{ "QNetworkInterface::InterfaceFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//93
	{ "QNetworkProxy::Capabilities", 0, Smoke::t_uint | Smoke::tf_stack },	//94
	{ "QNetworkProxy::Capabilities&", 0, Smoke::t_voidp | Smoke::tf_ref },	//95
	{ "QObject*", 23, Smoke::t_class | Smoke::tf_ptr },	//96
	{ "QPageSetupDialog::PageSetupDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//97
	{ "QPageSetupDialog::PageSetupDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//98
	{ "QPaintEngine::DirtyFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//99
	{ "QPaintEngine::DirtyFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//100
	{ "QPaintEngine::PaintEngineFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//101
	{ "QPaintEngine::PaintEngineFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//102
	{ "QPaintEvent*", 24, Smoke::t_class | Smoke::tf_ptr },	//103
	{ "QPainter::RenderHints", 0, Smoke::t_uint | Smoke::tf_stack },	//104
	{ "QPainter::RenderHints&", 0, Smoke::t_voidp | Smoke::tf_ref },	//105
	{ "QResizeEvent*", 26, Smoke::t_class | Smoke::tf_ptr },	//106
	{ "QShowEvent*", 27, Smoke::t_class | Smoke::tf_ptr },	//107
	{ "QSize", 28, Smoke::t_class | Smoke::tf_stack },	//108
	{ "QSizePolicy::ControlTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//109
	{ "QSizePolicy::ControlTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//110
	{ "QSql::ParamType", 0, Smoke::t_uint | Smoke::tf_stack },	//111
	{ "QSql::ParamType&", 0, Smoke::t_voidp | Smoke::tf_ref },	//112
	{ "QString", 0, Smoke::t_voidp | Smoke::tf_stack },	//113
	{ "QString::SectionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//114
	{ "QString::SectionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//115
	{ "QStringList", 0, Smoke::t_voidp | Smoke::tf_stack },	//116
	{ "QStyle&", 29, Smoke::t_class | Smoke::tf_ref },	//117
	{ "QStyle::State", 0, Smoke::t_uint | Smoke::tf_stack },	//118
	{ "QStyle::State&", 0, Smoke::t_voidp | Smoke::tf_ref },	//119
	{ "QStyle::SubControls", 0, Smoke::t_uint | Smoke::tf_stack },	//120
	{ "QStyle::SubControls&", 0, Smoke::t_voidp | Smoke::tf_ref },	//121
	{ "QStyleOptionButton::ButtonFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//122
	{ "QStyleOptionButton::ButtonFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//123
	{ "QStyleOptionFrameV2::FrameFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//124
	{ "QStyleOptionFrameV2::FrameFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//125
	{ "QStyleOptionQ3ListViewItem::Q3ListViewItemFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//126
	{ "QStyleOptionQ3ListViewItem::Q3ListViewItemFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//127
	{ "QStyleOptionTab::CornerWidgets", 0, Smoke::t_uint | Smoke::tf_stack },	//128
	{ "QStyleOptionTab::CornerWidgets&", 0, Smoke::t_voidp | Smoke::tf_ref },	//129
	{ "QStyleOptionToolBar::ToolBarFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//130
	{ "QStyleOptionToolBar::ToolBarFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//131
	{ "QStyleOptionToolButton::ToolButtonFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//132
	{ "QStyleOptionToolButton::ToolButtonFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//133
	{ "QStyleOptionViewItemV2::ViewItemFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//134
	{ "QStyleOptionViewItemV2::ViewItemFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//135
	{ "QTabletEvent*", 30, Smoke::t_class | Smoke::tf_ptr },	//136
	{ "QTextBoundaryFinder::BoundaryReasons", 0, Smoke::t_uint | Smoke::tf_stack },	//137
	{ "QTextBoundaryFinder::BoundaryReasons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//138
	{ "QTextCodec::ConversionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//139
	{ "QTextCodec::ConversionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//140
	{ "QTextDocument::FindFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//141
	{ "QTextDocument::FindFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//142
	{ "QTextEdit::AutoFormatting", 0, Smoke::t_uint | Smoke::tf_stack },	//143
	{ "QTextEdit::AutoFormatting&", 0, Smoke::t_voidp | Smoke::tf_ref },	//144
	{ "QTextFormat::PageBreakFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//145
	{ "QTextFormat::PageBreakFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//146
	{ "QTextItem::RenderFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//147
	{ "QTextItem::RenderFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//148
	{ "QTextOption::Flags", 0, Smoke::t_uint | Smoke::tf_stack },	//149
	{ "QTextOption::Flags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//150
	{ "QTextStream::NumberFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//151
	{ "QTextStream::NumberFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//152
	{ "QTimerEvent*", 31, Smoke::t_class | Smoke::tf_ptr },	//153
	{ "QTreeWidgetItemIterator::IteratorFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//154
	{ "QTreeWidgetItemIterator::IteratorFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//155
	{ "QUdpSocket::BindMode", 0, Smoke::t_uint | Smoke::tf_stack },	//156
	{ "QUdpSocket::BindMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//157
	{ "QUiLoader*", 32, Smoke::t_class | Smoke::tf_ptr },	//158
	{ "QUrl::FormattingOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//159
	{ "QUrl::FormattingOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//160
	{ "QVariant", 33, Smoke::t_class | Smoke::tf_stack },	//161
	{ "QWebPage::FindFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//162
	{ "QWebPage::FindFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//163
	{ "QWheelEvent*", 34, Smoke::t_class | Smoke::tf_ptr },	//164
	{ "QWidget*", 35, Smoke::t_class | Smoke::tf_ptr },	//165
	{ "QWidget::RenderFlag", 35, Smoke::t_enum | Smoke::tf_stack },	//166
	{ "QWidget::RenderFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//167
	{ "QWidget::RenderFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//168
	{ "QWizard::WizardOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//169
	{ "QWizard::WizardOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//170
	{ "Qt::Alignment", 0, Smoke::t_uint | Smoke::tf_stack },	//171
	{ "Qt::Alignment&", 0, Smoke::t_voidp | Smoke::tf_ref },	//172
	{ "Qt::AlignmentFlag", 36, Smoke::t_enum | Smoke::tf_stack },	//173
	{ "Qt::AnchorAttribute", 36, Smoke::t_enum | Smoke::tf_stack },	//174
	{ "Qt::ApplicationAttribute", 36, Smoke::t_enum | Smoke::tf_stack },	//175
	{ "Qt::ArrowType", 36, Smoke::t_enum | Smoke::tf_stack },	//176
	{ "Qt::AspectRatioMode", 36, Smoke::t_enum | Smoke::tf_stack },	//177
	{ "Qt::Axis", 36, Smoke::t_enum | Smoke::tf_stack },	//178
	{ "Qt::BGMode", 36, Smoke::t_enum | Smoke::tf_stack },	//179
	{ "Qt::BrushStyle", 36, Smoke::t_enum | Smoke::tf_stack },	//180
	{ "Qt::CaseSensitivity", 36, Smoke::t_enum | Smoke::tf_stack },	//181
	{ "Qt::CheckState", 36, Smoke::t_enum | Smoke::tf_stack },	//182
	{ "Qt::ClipOperation", 36, Smoke::t_enum | Smoke::tf_stack },	//183
	{ "Qt::ConnectionType", 36, Smoke::t_enum | Smoke::tf_stack },	//184
	{ "Qt::ContextMenuPolicy", 36, Smoke::t_enum | Smoke::tf_stack },	//185
	{ "Qt::Corner", 36, Smoke::t_enum | Smoke::tf_stack },	//186
	{ "Qt::CursorShape", 36, Smoke::t_enum | Smoke::tf_stack },	//187
	{ "Qt::DateFormat", 36, Smoke::t_enum | Smoke::tf_stack },	//188
	{ "Qt::DayOfWeek", 36, Smoke::t_enum | Smoke::tf_stack },	//189
	{ "Qt::DockWidgetArea", 36, Smoke::t_enum | Smoke::tf_stack },	//190
	{ "Qt::DockWidgetAreaSizes", 36, Smoke::t_enum | Smoke::tf_stack },	//191
	{ "Qt::DockWidgetAreas", 0, Smoke::t_uint | Smoke::tf_stack },	//192
	{ "Qt::DockWidgetAreas&", 0, Smoke::t_voidp | Smoke::tf_ref },	//193
	{ "Qt::DropAction", 36, Smoke::t_enum | Smoke::tf_stack },	//194
	{ "Qt::DropActions", 0, Smoke::t_uint | Smoke::tf_stack },	//195
	{ "Qt::DropActions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//196
	{ "Qt::EventPriority", 36, Smoke::t_enum | Smoke::tf_stack },	//197
	{ "Qt::FillRule", 36, Smoke::t_enum | Smoke::tf_stack },	//198
	{ "Qt::FocusPolicy", 36, Smoke::t_enum | Smoke::tf_stack },	//199
	{ "Qt::FocusReason", 36, Smoke::t_enum | Smoke::tf_stack },	//200
	{ "Qt::GlobalColor", 36, Smoke::t_enum | Smoke::tf_stack },	//201
	{ "Qt::HitTestAccuracy", 36, Smoke::t_enum | Smoke::tf_stack },	//202
	{ "Qt::ImageConversionFlag", 36, Smoke::t_enum | Smoke::tf_stack },	//203
	{ "Qt::ImageConversionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//204
	{ "Qt::ImageConversionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//205
	{ "Qt::InputMethodQuery", 36, Smoke::t_enum | Smoke::tf_stack },	//206
	{ "Qt::ItemDataRole", 36, Smoke::t_enum | Smoke::tf_stack },	//207
	{ "Qt::ItemFlag", 36, Smoke::t_enum | Smoke::tf_stack },	//208
	{ "Qt::ItemFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//209
	{ "Qt::ItemFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//210
	{ "Qt::ItemSelectionMode", 36, Smoke::t_enum | Smoke::tf_stack },	//211
	{ "Qt::Key", 36, Smoke::t_enum | Smoke::tf_stack },	//212
	{ "Qt::KeyboardModifier", 36, Smoke::t_enum | Smoke::tf_stack },	//213
	{ "Qt::KeyboardModifiers", 0, Smoke::t_uint | Smoke::tf_stack },	//214
	{ "Qt::KeyboardModifiers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//215
	{ "Qt::LayoutDirection", 36, Smoke::t_enum | Smoke::tf_stack },	//216
	{ "Qt::MaskMode", 36, Smoke::t_enum | Smoke::tf_stack },	//217
	{ "Qt::MatchFlag", 36, Smoke::t_enum | Smoke::tf_stack },	//218
	{ "Qt::MatchFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//219
	{ "Qt::MatchFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//220
	{ "Qt::Modifier", 36, Smoke::t_enum | Smoke::tf_stack },	//221
	{ "Qt::MouseButton", 36, Smoke::t_enum | Smoke::tf_stack },	//222
	{ "Qt::MouseButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//223
	{ "Qt::MouseButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//224
	{ "Qt::Orientation", 36, Smoke::t_enum | Smoke::tf_stack },	//225
	{ "Qt::Orientations", 0, Smoke::t_uint | Smoke::tf_stack },	//226
	{ "Qt::Orientations&", 0, Smoke::t_voidp | Smoke::tf_ref },	//227
	{ "Qt::PenCapStyle", 36, Smoke::t_enum | Smoke::tf_stack },	//228
	{ "Qt::PenJoinStyle", 36, Smoke::t_enum | Smoke::tf_stack },	//229
	{ "Qt::PenStyle", 36, Smoke::t_enum | Smoke::tf_stack },	//230
	{ "Qt::ScrollBarPolicy", 36, Smoke::t_enum | Smoke::tf_stack },	//231
	{ "Qt::ShortcutContext", 36, Smoke::t_enum | Smoke::tf_stack },	//232
	{ "Qt::SizeHint", 36, Smoke::t_enum | Smoke::tf_stack },	//233
	{ "Qt::SizeMode", 36, Smoke::t_enum | Smoke::tf_stack },	//234
	{ "Qt::SortOrder", 36, Smoke::t_enum | Smoke::tf_stack },	//235
	{ "Qt::TextElideMode", 36, Smoke::t_enum | Smoke::tf_stack },	//236
	{ "Qt::TextFlag", 36, Smoke::t_enum | Smoke::tf_stack },	//237
	{ "Qt::TextFormat", 36, Smoke::t_enum | Smoke::tf_stack },	//238
	{ "Qt::TextInteractionFlag", 36, Smoke::t_enum | Smoke::tf_stack },	//239
	{ "Qt::TextInteractionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//240
	{ "Qt::TextInteractionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//241
	{ "Qt::TimeSpec", 36, Smoke::t_enum | Smoke::tf_stack },	//242
	{ "Qt::ToolBarArea", 36, Smoke::t_enum | Smoke::tf_stack },	//243
	{ "Qt::ToolBarAreaSizes", 36, Smoke::t_enum | Smoke::tf_stack },	//244
	{ "Qt::ToolBarAreas", 0, Smoke::t_uint | Smoke::tf_stack },	//245
	{ "Qt::ToolBarAreas&", 0, Smoke::t_voidp | Smoke::tf_ref },	//246
	{ "Qt::ToolButtonStyle", 36, Smoke::t_enum | Smoke::tf_stack },	//247
	{ "Qt::TransformationMode", 36, Smoke::t_enum | Smoke::tf_stack },	//248
	{ "Qt::UIEffect", 36, Smoke::t_enum | Smoke::tf_stack },	//249
	{ "Qt::WhiteSpaceMode", 36, Smoke::t_enum | Smoke::tf_stack },	//250
	{ "Qt::WidgetAttribute", 36, Smoke::t_enum | Smoke::tf_stack },	//251
	{ "Qt::WindowFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//252
	{ "Qt::WindowFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//253
	{ "Qt::WindowFrameSection", 36, Smoke::t_enum | Smoke::tf_stack },	//254
	{ "Qt::WindowModality", 36, Smoke::t_enum | Smoke::tf_stack },	//255
	{ "Qt::WindowState", 36, Smoke::t_enum | Smoke::tf_stack },	//256
	{ "Qt::WindowStates", 0, Smoke::t_uint | Smoke::tf_stack },	//257
	{ "Qt::WindowStates&", 0, Smoke::t_voidp | Smoke::tf_ref },	//258
	{ "Qt::WindowType", 36, Smoke::t_enum | Smoke::tf_stack },	//259
	{ "bool", 0, Smoke::t_bool | Smoke::tf_stack },	//260
	{ "const QDir&", 7, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//261
	{ "const QFont&", 14, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//262
	{ "const QMetaObject", 20, Smoke::t_class | Smoke::tf_stack | Smoke::tf_const },	//263
	{ "const QMetaObject*", 20, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//264
	{ "const QPalette&", 25, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//265
	{ "const QString&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//266
	{ "const char*", 0, Smoke::t_voidp | Smoke::tf_ptr | Smoke::tf_const },	//267
	{ "int", 0, Smoke::t_int | Smoke::tf_stack },	//268
	{ "void**", 0, Smoke::t_voidp | Smoke::tf_ptr },	//269
};

static Smoke::Index qtuitools_argumentList[] = {
	0,	//0  (void)
	153, 0,	//1  QTimerEvent*  
	16, 0,	//3  QChildEvent*  
	260, 0,	//5  bool  
	261, 0,	//7  const QDir&  
	266, 0,	//9  const QString&  
	266, 165, 0,	//11  const QString&, QWidget*  
	266, 165, 266, 0,	//14  const QString&, QWidget*, const QString&  
	266, 96, 0,	//18  const QString&, QObject*  
	266, 96, 266, 0,	//21  const QString&, QObject*, const QString&  
	267, 0,	//25  const char*  
	267, 267, 0,	//27  const char*, const char*  
	40, 0,	//30  QEvent*  
	65, 0,	//32  QIODevice*  
	65, 165, 0,	//34  QIODevice*, QWidget*  
	89, 268, 269, 0,	//37  QMetaObject::Call, int, void**  
	96, 0,	//41  QObject*  
	96, 266, 0,	//43  QObject*, const QString&  
	96, 40, 0,	//46  QObject*, QEvent*  
};

// Raw list of all methods, using munged names
static const char *qtuitools_methodNames[] = {
    "",	//0
    "QUiLoader",	//1
    "QUiLoader#",	//2
    "addPluginPath",	//3
    "addPluginPath$",	//4
    "availableLayouts",	//5
    "availableWidgets",	//6
    "childEvent",	//7
    "childEvent#",	//8
    "clearPluginPaths",	//9
    "connectNotify",	//10
    "connectNotify$",	//11
    "createAction",	//12
    "createAction#",	//13
    "createAction#$",	//14
    "createActionGroup",	//15
    "createActionGroup#",	//16
    "createActionGroup#$",	//17
    "createLayout",	//18
    "createLayout$",	//19
    "createLayout$#",	//20
    "createLayout$#$",	//21
    "createWidget",	//22
    "createWidget$",	//23
    "createWidget$#",	//24
    "createWidget$#$",	//25
    "customEvent",	//26
    "customEvent#",	//27
    "disconnectNotify",	//28
    "disconnectNotify$",	//29
    "event",	//30
    "event#",	//31
    "eventFilter",	//32
    "eventFilter##",	//33
    "isLanguageChangeEnabled",	//34
    "isScriptingEnabled",	//35
    "isTranslationEnabled",	//36
    "load",	//37
    "load#",	//38
    "load##",	//39
    "metaObject",	//40
    "pluginPaths",	//41
    "qt_metacall",	//42
    "qt_metacall$$?",	//43
    "setLanguageChangeEnabled",	//44
    "setLanguageChangeEnabled$",	//45
    "setScriptingEnabled",	//46
    "setScriptingEnabled$",	//47
    "setTranslationEnabled",	//48
    "setTranslationEnabled$",	//49
    "setWorkingDirectory",	//50
    "setWorkingDirectory#",	//51
    "staticMetaObject",	//52
    "timerEvent",	//53
    "timerEvent#",	//54
    "tr",	//55
    "tr$",	//56
    "tr$$",	//57
    "workingDirectory",	//58
    "~QUiLoader",	//59
};

// (classId, name (index in methodNames), argumentList index, number of args, method flags, return type (index in types), xcall() index)
static Smoke::Method qtuitools_methods[] = {
	{23, 40, 0, 0, Smoke::mf_const, 264, 2},	//0 QObject::metaObject() const
	{23, 42, 37, 3, 0, 268, 3},	//1 QObject::qt_metacall(QMetaObject::Call, int, void**)
	{23, 30, 30, 1, 0, 260, 6},	//2 QObject::event(QEvent*)
	{23, 32, 46, 2, 0, 260, 7},	//3 QObject::eventFilter(QObject*, QEvent*)
	{23, 53, 1, 1, Smoke::mf_protected, 0, 49},	//4 QObject::timerEvent(QTimerEvent*)
	{23, 7, 3, 1, Smoke::mf_protected, 0, 50},	//5 QObject::childEvent(QChildEvent*)
	{23, 26, 30, 1, Smoke::mf_protected, 0, 51},	//6 QObject::customEvent(QEvent*)
	{23, 10, 25, 1, Smoke::mf_protected, 0, 52},	//7 QObject::connectNotify(const char*)
	{23, 28, 25, 1, Smoke::mf_protected, 0, 53},	//8 QObject::disconnectNotify(const char*)
	{32, 40, 0, 0, Smoke::mf_const, 264, 2},	//9 QUiLoader::metaObject() const
	{32, 42, 37, 3, 0, 268, 3},	//10 QUiLoader::qt_metacall(QMetaObject::Call, int, void**)
	{32, 1, 41, 1, Smoke::mf_ctor, 158, 4},	//11 QUiLoader::QUiLoader(QObject*)
	{32, 1, 0, 0, Smoke::mf_ctor, 158, 5},	//12 QUiLoader::QUiLoader()
	{32, 59, 0, 0, Smoke::mf_dtor, 0, 35},	//13 QUiLoader::~QUiLoader()
	{32, 41, 0, 0, Smoke::mf_const, 116, 6},	//14 QUiLoader::pluginPaths() const
	{32, 9, 0, 0, 0, 0, 7},	//15 QUiLoader::clearPluginPaths()
	{32, 3, 9, 1, 0, 0, 8},	//16 QUiLoader::addPluginPath(const QString&)
	{32, 37, 34, 2, 0, 165, 9},	//17 QUiLoader::load(QIODevice*, QWidget*)
	{32, 37, 32, 1, 0, 165, 10},	//18 QUiLoader::load(QIODevice*)
	{32, 6, 0, 0, Smoke::mf_const, 116, 11},	//19 QUiLoader::availableWidgets() const
	{32, 5, 0, 0, Smoke::mf_const, 116, 12},	//20 QUiLoader::availableLayouts() const
	{32, 22, 14, 3, 0, 165, 13},	//21 QUiLoader::createWidget(const QString&, QWidget*, const QString&)
	{32, 22, 11, 2, 0, 165, 14},	//22 QUiLoader::createWidget(const QString&, QWidget*)
	{32, 22, 9, 1, 0, 165, 15},	//23 QUiLoader::createWidget(const QString&)
	{32, 18, 21, 3, 0, 76, 16},	//24 QUiLoader::createLayout(const QString&, QObject*, const QString&)
	{32, 18, 18, 2, 0, 76, 17},	//25 QUiLoader::createLayout(const QString&, QObject*)
	{32, 18, 9, 1, 0, 76, 18},	//26 QUiLoader::createLayout(const QString&)
	{32, 15, 43, 2, 0, 15, 19},	//27 QUiLoader::createActionGroup(QObject*, const QString&)
	{32, 15, 41, 1, 0, 15, 20},	//28 QUiLoader::createActionGroup(QObject*)
	{32, 15, 0, 0, 0, 15, 21},	//29 QUiLoader::createActionGroup()
	{32, 12, 43, 2, 0, 13, 22},	//30 QUiLoader::createAction(QObject*, const QString&)
	{32, 12, 41, 1, 0, 13, 23},	//31 QUiLoader::createAction(QObject*)
	{32, 12, 0, 0, 0, 13, 24},	//32 QUiLoader::createAction()
	{32, 50, 7, 1, 0, 0, 25},	//33 QUiLoader::setWorkingDirectory(const QDir&)
	{32, 58, 0, 0, Smoke::mf_const, 27, 26},	//34 QUiLoader::workingDirectory() const
	{32, 46, 5, 1, 0, 0, 27},	//35 QUiLoader::setScriptingEnabled(bool)
	{32, 35, 0, 0, Smoke::mf_const, 260, 28},	//36 QUiLoader::isScriptingEnabled() const
	{32, 44, 5, 1, 0, 0, 29},	//37 QUiLoader::setLanguageChangeEnabled(bool)
	{32, 34, 0, 0, Smoke::mf_const, 260, 30},	//38 QUiLoader::isLanguageChangeEnabled() const
	{32, 48, 5, 1, 0, 0, 31},	//39 QUiLoader::setTranslationEnabled(bool)
	{32, 36, 0, 0, Smoke::mf_const, 260, 32},	//40 QUiLoader::isTranslationEnabled() const
	{32, 55, 27, 2, Smoke::mf_static, 113, 33},	//41 QUiLoader::tr(const char*, const char*)
	{32, 55, 25, 1, Smoke::mf_static, 113, 34},	//42 QUiLoader::tr(const char*)
	{32, 52, 0, 0, Smoke::mf_static, 263, 1},	//43 QUiLoader::staticMetaObject (static var)
};

// Class ID, munged name ID (index into methodNames), method def (see methods) if >0 or number of overloads if <0
static Smoke::MethodMap qtuitools_methodMaps[] = {
	{ 0, 0, 0 },	//0 (no method)
	{32, 1, 12},	//1 QUiLoader::QUiLoader
	{32, 2, 11},	//2 QUiLoader::QUiLoader#
	{32, 4, 16},	//3 QUiLoader::addPluginPath$
	{32, 5, 20},	//4 QUiLoader::availableLayouts
	{32, 6, 19},	//5 QUiLoader::availableWidgets
	{32, 9, 15},	//6 QUiLoader::clearPluginPaths
	{32, 12, 32},	//7 QUiLoader::createAction
	{32, 13, 31},	//8 QUiLoader::createAction#
	{32, 14, 30},	//9 QUiLoader::createAction#$
	{32, 15, 29},	//10 QUiLoader::createActionGroup
	{32, 16, 28},	//11 QUiLoader::createActionGroup#
	{32, 17, 27},	//12 QUiLoader::createActionGroup#$
	{32, 19, 26},	//13 QUiLoader::createLayout$
	{32, 20, 25},	//14 QUiLoader::createLayout$#
	{32, 21, 24},	//15 QUiLoader::createLayout$#$
	{32, 23, 23},	//16 QUiLoader::createWidget$
	{32, 24, 22},	//17 QUiLoader::createWidget$#
	{32, 25, 21},	//18 QUiLoader::createWidget$#$
	{32, 34, 38},	//19 QUiLoader::isLanguageChangeEnabled
	{32, 35, 36},	//20 QUiLoader::isScriptingEnabled
	{32, 36, 40},	//21 QUiLoader::isTranslationEnabled
	{32, 38, 18},	//22 QUiLoader::load#
	{32, 39, 17},	//23 QUiLoader::load##
	{32, 40, 9},	//24 QUiLoader::metaObject
	{32, 41, 14},	//25 QUiLoader::pluginPaths
	{32, 43, 10},	//26 QUiLoader::qt_metacall$$?
	{32, 45, 37},	//27 QUiLoader::setLanguageChangeEnabled$
	{32, 47, 35},	//28 QUiLoader::setScriptingEnabled$
	{32, 49, 39},	//29 QUiLoader::setTranslationEnabled$
	{32, 51, 33},	//30 QUiLoader::setWorkingDirectory#
	{32, 52, 43},	//31 QUiLoader::staticMetaObject
	{32, 56, 42},	//32 QUiLoader::tr$
	{32, 57, 41},	//33 QUiLoader::tr$$
	{32, 58, 34},	//34 QUiLoader::workingDirectory
	{32, 59, 13},	//35 QUiLoader::~QUiLoader
};

static Smoke::Index qtuitools_ambiguousMethodList[] = {
    0,
};


void init_qt_Smoke();

static bool initialized = false;
Smoke *qtuitools_Smoke = 0;

// Create the Smoke instance encapsulating all the above.
void init_qtuitools_Smoke() {
    if (initialized) return;
    init_qt_Smoke();
    qtuitools_Smoke = new Smoke(
        "qtuitools",
        qtuitools_classes, 36,
        qtuitools_methods, 44,
        qtuitools_methodMaps, 35,
        qtuitools_methodNames, 59,
        qtuitools_types, 269,
        qtuitools_inheritanceList,
        qtuitools_argumentList,
        qtuitools_ambiguousMethodList,
        qtuitools_cast );
    initialized = true;
}
